############4́@WXeBbNA/^
# Working directory 'toyoda' ł邱Ƃ̊mF
(n_wd<-getwd())                #working directory(wd)̊mF
(setwd('./scrT'))              #wd̈ړ
source('../myfunc/myfunc.R')   #֐̓ǂݍ
(setwd(n_wd))                  #wd߂
library(rstan)                 #pbP[WrstaňĂяo
library(cmdstanr)              #pbP[WcmdstanřĂяo
library(posterior)             #pbP[WposteriořĂяo
prob<-c(0.025, 0.05, 0.5, 0.95, 0.975) #m_̒`

#############4.1@WXeBbNAixkCzj
### \4.1 ǗEۂƔN
(i<-read.csv("./scrT/dat/ےi.csv", header = TRUE))

### \4.2 Nʂ̊ǗE҂̐l
table(i);                                           #\4.2

###}4.1 Uz}ƉA
temp<-i[,2]+runif(200,-0.5,0.5); #}₷闐t
plot(temp,i[,1],ylim=c(-0.2,1.2),xlim=c(30,46),
  xlab="N",ylab="ǗE");
  abline(a= -3.06335, b=0.09377, lwd=1.8);
  text(40,0.6,"A",cex=1.5);               #}4.1܂

### 4. 1. 2 WXeBbNϊ
#IbYϊ@Ŝmւ̕ϊ            (4.4)
odds<-function(prob){prob/(1-prob)}
plot(odds,0,1,xlab="m",main="IbYϊ")

#WbgϊiΐIbYϊj                  (4.5)
log_odds<-function(prob){log(prob/(1-prob))}
plot(log_odds,0,1,xlab="m",main="Wbgϊ")

#WXeBbNϊiWbgϊ̋tϊj      (4.7)
logistic<-function(yhat){1/(1+exp((-1)*yhat))}

###}4.2 tWbg֐logit-1( )
plot(logistic,-3,3,xlab="yhat",main="WXeBbNϊ")


###############WXeBbNA(xkCz)stanR[h
logistic_reg_01<-'
data { 
  int<lower=0>  n;                     //f[^ 
  int<lower=0,upper=1>  y[n];          //ϐ(0-1f[^)   
  vector[n]   X;                       //\ϐxNg   
}
parameters {
  real        a;                       //ؕ
  real        b;                       //ΉAW 
}
transformed parameters {
  vector<lower=0,upper=1>[n]  prob;
  for(i in 1:n)
  prob[i] = inv_logit(a + X[i]*b);     //m (4.10)
}
model {
  for(i in 1:n)
    y[i] ~ bernoulli(prob[i]);         //xkCzf(4.8)
}
';

par<-c("a","b")                                        #ꐔ
dataSet01 <-list(n=nrow(i),y=i[,1], X=i[,2] ) #

###########cmdstanrɂs
modfile01 <- write_stan_file(logistic_reg_01)       #oꎞt@C
mod01 <- cmdstan_model(modfile01)                   #RpC
csrfit01 <- mod01$sample(data = dataSet01,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit <- rstan::read_stan_csv(csrfit01$output_files())   #stan`ւ̕ϊ

###########rstanɂs
#fit<-stan(model_code =logistic_reg_01,data=dataSet01,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit,  file="./scrT/obje/stan_obje0401")
#load(file="./scrT/obje/stan_obje0401"); #\stan( )ōobject[h

ext<-extract(fit, par);               #̎o

#####㕪z̃qXgOiȏɂ͂Ȃj
hist(ext$a,breaks=100)
hist(ext$b,breaks=100)

###############
p0_5<- (-1)*ext$a/ext$b;         #50%̊mŉےɂȂN  p.46,l.3
oddshi<-exp(ext$b);              #N1Ες̃IbY (4.13)
p35<- 1/(1+exp((-1)*(ext$a+ext$b*35))); #35΂ŏiłm   (4.14)

###\4.3 ꐔƐʂ̎㕪z̗v
gqcal(ext$a);
gqcal(ext$b);
gqcal(p0_5);  
gqcal(oddshi);
gqcal(p35)

###}4.3 N̏㏸ɔim̕ω
plot(temp,i[,1],ylim=c(-0.2,1.2),xlim=c(30,46),
    xlab="N",ylab="ǗE",main="WXeBbNA")
  par(new=T)
  curve(1/(1+exp((-1)*((-18.679)+0.492*x))),30,46,lwd=1.8,
    ylim=c(-0.2,1.2),xlim=c(30,46),xlab="",ylab="");      #}4.3܂


##############  4.2  WXeBbNAi2z)

###\4.4 ǂ̉bif[^
(ǌP<-read.csv("./scrT/dat/ǌP.csv", header = TRUE));#\4.4

###}4.4 P񐔂Ɛ̐܂Ot
(ab<-coef(glm(ǌP[,2]/ǌP[,1]~ǌP[,3])))
plot(ǌP[,3],ǌP[,2]/ǌP[,1],
      ylim=c(0,1),type="o",xlab="P",ylab="")
      abline(a=ab[1],b=ab[2]);                             #}4.4܂


############}4.5   2z̊m֐P
size<-10; 
for (prob in (1:9)/10 ){
  x<-c(0:size)
  plot(x, dbinom(x, size, prob), type="o", 
        main=paste("2z@size:",size,", prob:",prob) )
  locator(); #ENbN"~"
}

############}4.5   2z̊m֐
size<-10;x<-c(0:size)
plot(x, dbinom(x, size, 0.1), type="o",ylim=c(0,0.4),xlab="",ylab="") 
text(1,0.3,paste("p=",prob,sep=""))
for (prob in c(0.3,0.5,0.7,0.9)){
  par(new=T)
  plot(x, dbinom(x, size, prob), type="o",ylim=c(0,0.4),xlab="",ylab="") 
  text(prob*10,0.3,paste("p=",prob,sep=""))
}

###########sꍇiKzƕςȂȂjȏɂ͂Ȃ
size<-100; 
for (prob in (1:9)/10 ){
  x<-c(0:size)
  plot(x, dbinom(x, size, prob), type="o", 
        main=paste("2z@size:",size,", prob:",prob) )
  locator(); #ENbN"~"
}

################WXeBbNAi2zjstanR[h
binom_reg<-'
data { 
  int<lower=0>  n;                  //f[^ 
  int<lower=0>  t[n];               //s 
  int<lower=0>  y[n];               // 
  vector[n]   X;                    //\ϐxNg   
}
parameters {
  real        a;                    //ؕ
  real        b;                    //ΉAW
}
transformed parameters {
  vector<lower=0,upper=1>[n]  prob;
  for(i in 1:n)
  prob[i] = inv_logit(a + X[i]*b);  //m  ,(4.17)
}
model {
  for(i in 1:n)
    y[i] ~ binomial(t[i], prob[i]); //2zf(4.16),(4.17)
}
';

par<-c("a","b")                                       #ꐔ
dataSet02 <-list(n=nrow(ǌP),t=ǌP[,1],y=ǌP[,2],
                 X=ǌP[,3] )                   #

###########cmdstanrɂs
modfile02 <- write_stan_file(binom_reg)             #oꎞt@C
mod02 <- cmdstan_model(modfile02)                   #RpC
csrfit02 <- mod02$sample(data = dataSet02,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit02 <- rstan::read_stan_csv(csrfit02$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit02<-stan(model_code =binom_reg,data=dataSet02,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit02,  file="./scrT/obje/stan_obje0402")
#load(file="./scrT/obje/stan_obje0402"); #\stan( )ōobject[h

ext<-extract(fit02, par);               #̎o

###############㕪zƐ
p0_5<- (-1)*ext$a/ext$b;      #\ł悤ɂȂP p,50,l.1
oddshi<-exp(ext$b);           #PPꍇ̃IbY     p,50,l.4
p35<- 1/(1+exp((-1)*(ext$a+ext$b*35)));    #(4.14)35  p,50,l.6
p35aste<-rbinom(length(p35),15,p35);       #(4.19)

#####\4.5 ꐔƐʂ̎㕪z̗v
gqcal(ext$a  ,3);             #ؕ
gqcal(ext$b  ,3);             #X
gqcal(p0_5   ,1);             #\ł悤ɂȂP
gqcal(oddshi ,2);             #PPꍇ̃IbY
gqcal(p35    ,3);             #ƂTPꍇ̐
gqcal(p35aste,1);             #35ڂ̊{ꐔ15̏ꍇ̕\̎㕪z

#####}4.6 WXeBbNA(2 z)
plot(ǌP[,3],ǌP[,2]/ǌP[,1],         
    ylim=c(0,1),xlim=c(0,36),type="o",xlab="P",ylab="")
  par(new=T)
  curve(1/(1+exp((-1)*((-1.803)+0.099*x))),0,36,lwd=1.8,
    ylim=c(0,1),xlim=c(0,36),xlab="",ylab="");
    lines(c(35,35),c(0.747,0.905),lwd=1.8)
    text(33,0.95,"95mM");                          #}4.6܂

#####}4.7 x = 35, n = 15 ̂Ƃ́u\v̎\z
hist(p35aste)

##### 4.3 ^

######4.3.1 O
######\4.10 BCG ̗LɊւÕr[
(O<-read.csv("./scrT/dat/jOBCG.csv", header = TRUE))

round(riskO<-O[1,3]/(O[1,3]+O[1,4]),4);   #XN(4.20)
round(riskΑO<-O[1,5]/(O[1,5]+O[1,6]),4);   #      (4.21)
round(riskO/riskΑO,3);                           #XN
round((O[1,3]*O[1,6])/(O[1,4]*O[1,5]),3); #IbY(4.22)

######4.3.2 
#####\4.12 BCG ̗LɊւ̃r[
(<-read.csv("./scrT/dat/jBCG.csv", header = TRUE))   #\4.12
round(risk<-[1,3]/([1,3]+[1,4]),4);   #XN(4.23)
round(riskΌ<-[1,5]/([1,5]+[1,6]),4);   #      (4.24)
round(([1,3]*[1,6])/([1,4]*[1,5]),3); #IbY(4.25)


###########################^́iIbY)stanR[h
meta_ana<-'
data { 
  int<lower=0>  m;                  // 
  int<lower=0>  u1[m];              //IbY̕q 
  int<lower=0>  n1[m];              //IbY̕qs 
  int<lower=0>  u0[m];              //IbY̕ꐬ 
  int<lower=0>  n0[m];              //IbY̕ꎎs 
}
parameters {
  real        a[m];                 //ؕ
  real        b[m];                 //W
  real        mu_a;                 //ؕЕ
  real        mu_b;                 //W
  real        sigma_a;              //ؕSD
  real        sigma_b;              //WSD
}
model {
  for(i in 1:m){
    a[i]  ~ normal(mu_a,  sigma_a);  //ؕЂ̎Oz(4.30)
    b[i]  ~ normal(mu_b,  sigma_b);  //W̎Oz(4.31)
    u1[i] ~ binomial(n1[i], inv_logit(a[i] + b[i]));//(4.26),(4.28),(4.34)
    u0[i] ~ binomial(n0[i], inv_logit(a[i]       ));//(4.26),(4.29),(4.35)
  }
}
generated quantities{
  real     Odds_r[m];  
  real     Odds_r_mu;  
  Odds_r   =exp(b);                 //Ƃ̃IbY(4.13),p.55,l.4
  Odds_r_mu=exp(mu_b);              //IbY̕ p.55,l.7
}
';

##########4.3.4 Õ^

par<-c("Odds_r","Odds_r_mu","mu_b","sigma_b")           #ꐔ
dataSetO <-list(m=nrow(O),
      u1=O$u11,n1=O$u11+O$u12,
      u0=O$u21,n0=O$u21+O$u22)                 #

###########cmdstanrɂs
modfileO <- write_stan_file(meta_ana)              #oꎞt@C  
modO <- cmdstan_model(modfileO)                   #RpC
csrfitO <- modO$sample(data = dataSetO,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitO <- rstan::read_stan_csv(csrfitO$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitO<-stan(model_code =meta_ana,data=dataSetO,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitO,  file="./scrT/obje/stan_obje0403")
#load(file="./scrT/obje/stan_obje0403"); #\stan( )ōobject[h

extO<-extract(fitO, par);               #̎o

#####\4.10 Odds/EAP
print(fitO,digits_summary=3,prob=prob)

#####IbY̕ς̎㕪z̃qXgOiȏɂ͂Ȃj
hist(extO$Odds_r_mu,breaks=200,xlim=c(0,1.0),main="")

#####IbY̎\z(4.33)̃qXgOiȏɂ͂Ȃj
Odds_r_aste<-exp(rnorm(length(extO$mu_b),extO$mu_b,extO$sigma_b))
hist(Odds_r_aste,breaks=1000,xlim=c(0,4.0),main="")

####\4.11 ÕIbY̕ς̎㕪zƎ\z̗v
gqcal(exp(extO$mu_b),3);  #\4.11
gqcal(Odds_r_aste,3)

####phc p,55,bl.3
mean(1.0<Odds_r_aste)
mean(Odds_r_aste<0.8)

#ueÕIbY̎㕪z̔Ђ}v(ȏɂ͂Ȃ)
aa<-extO$Odds_r[,1]; for (i in 2:13){aa<-c(aa,extO$Odds_r[,i])};
boxplot(aa~rep(1:13,each=100000),outline=F,horizontal=T,cex.axis=1.2);
abline(v=1.0,lwd=2.0)


###########4.3.5 ̃^

par<-c("Odds_r","Odds_r_mu","mu_b","sigma_b")                #ꐔ  
dataSet <-list(m=nrow(),
      u1=$u11,n1=$u11+$u21,
      u0=$u12,n0=$u12+$u22)                      #

###########cmdstanrɂs
                                                       #RpC"modO"
csrfit <- modO$sample(data = dataSet,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit <- rstan::read_stan_csv(csrfit$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit<-stan(model_code =meta_ana,data=dataSet,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit,  file="./scrT/obje/stan_obje0404")
#load(file="./scrT/obje/stan_obje0404"); #\stan( )ōobject[h

ext<-extract(fit, par);               #̎o

####\4.12 Odds/EAP
print(fit,digits_summary=3,prob=prob)
Odds_r_aste<-exp(rnorm(length(ext$mu_b),ext$mu_b,ext$sigma_b))

####\4.13 ̃IbY̕ς̎㕪zƎ\z̗v
gqcal(exp(ext$mu_b),3)
gqcal(Odds_r_aste,3)

#####phc p.57.bl.1
mean(1.0<Odds_r_aste)
mean(Odds_r_aste<0.8)

####}4.8 ẽIbY̎㕪z
aa<-ext$Odds_r[,1]; for (i in 2:10){aa<-c(aa,ext$Odds_r[,i])}
boxplot(aa~rep(1:10,each=100000),outline=F,horizontal=T,cex.axis=1.5);
abline(v=1.0,lwd=2.0)


#################Kۑ
###  1.
#load(file="./scrT/obje/stan_obje0401"); #\stan( )ōobject[h
par<-c("a","b")                  
ext<-extract(fit, par);               #̎o
p0_5<- (-1)*ext$a/ext$b;       #50%̊mŉےɂȂN
oddshi<-exp(ext$b);              #N1Ες̃IbY
p35<- 1/(1+exp((-1)*(ext$a+ext$b*35))); #35΂ŏiłm
gqcal(p0_5)
gqcal(oddshi)

#
#  ֐ phc01 g͊
#

###  2.
#load(file="./scrT/obje/stan_obje0402"); #\stan( )ōobject[h
par<-c("a","b")                  
ext<-extract(fit02, par);               #̎o
p35<- 1/(1+exp((-1)*(ext$a+ext$b*35))); #ƂTPꍇ̐
gqcal(p35)

#
#  ֐ phc01 g͊
#

###  3.
#load(file="./scrT/obje/stan_obje0404"); #\stan( )ōobject[h
par<-c("Odds_r","Odds_r_mu","mu_b","sigma_b")                  
ext<-extract(fit, par);               #̎o               
gqcal(ext$Odds_r_mu) 
phc01(seq(0.25,0.70,0.01),ext$Odds_r_mu,cc="gtc",byoga="yes",
      xlab="IbY̕")
phc01(seq(0.25,0.70,0.05),ext$Odds_r_mu,cc="gtc",byoga="no")
Odds_r_aste<-exp(rnorm(length(ext$mu_b),ext$mu_b,ext$sigma_b))
gqcal(Odds_r_aste,3)
phc01(seq(0.05,2.1,0.01),ext$Odds_r_mu,cc="gtc",byoga="yes",
      xlab="IbY̎\z")
phc01(seq(0.05,0.3,0.05),ext$Odds_r_mu,cc="gtc",byoga="no")
