############T́@|A\f^ΐ`f
# Working directory 'toyoda' ł邱Ƃ̊mF
(n_wd<-getwd())                #working directory(wd)̊mF
(setwd('./scrT'))              #wd̈ړ
source('../myfunc/myfunc.R')   #֐̓ǂݍ
(setwd(n_wd))                  #wd߂
library(rstan)                 #pbP[WrstaňĂяo
library(cmdstanr)              #pbP[WcmdstanřĂяo
library(posterior)             #pbP[WposteriořĂяo
prob<-c(0.025, 0.05, 0.5, 0.95, 0.975) #m_̒`

#################5.1 |A\z

###}5.1 |A\z̊m֐
par(mfrow=c(1,2))
  u<-c(0:5);p061<-dpois(u, 0.61);names(p061)<-u
  barplot(p061); text(4,0.3,"=0.61",cex=2.0)
  x<-c(0:10)
  plot(x, dpois(x, 2.0), type="o",xlab="",ylab="",xlim=c(0,10),ylim=c(0,0.3))
  for (lambda in seq(3.0,6.0,1.0)){
    par(new=T)
    plot(x,dpois(x,lambda),type="o",xlab="",ylab="",xlim=c(0,10),ylim=c(0,0.3))
  }
  text(c(2,3,4,5,6),c(0.29,0.25,0.22,0.19,0.18),
    paste("=",2:6,sep=""),cex=1.5)
par(mfrow=c(1,1));                                    #}5.1܂
#dev.copy2eps(file="z0401.eps",family="Japan1")

####lambda傫ȂƐKzɋߎ(ȏɂ͂Ȃ)
size<-100; x<-c(0:size);
plot(x, dpois(x, 50), type="o",main=paste("|A\z@lambda:",50))


###5.1.1 l(nɏRĎSm)
###\5.1 vVARŔnɏRĎSm
Horse<-c(dpois(0, 0.61),dpois(1, 0.61),dpois(2, 0.61),
         dpois(3, 0.61),dpois(4, 0.61),dpois(5, 0.61));
print(0:5);print(c(109, 65, 22, 3, 1, 0));round(Horse,4);round(Horse*200,1)

###5.1.2 l(̖{̊m)
ice<-c(dpois(0, 0.25),dpois(1, 0.25),dpois(2, 0.25),           #(5.7)
   dpois(3, 0.25),dpois(4, 0.25));round(ice,3)

#################5.2@|A\z̐
####5.2.1@eƋ搔̃f[^
e<-c(rep(0,229),rep(1,211),rep(2,93),rep(3,35),rep(4,7),rep(5,1))

###\5.2 hɂ锚eƎ\`FbN ̑O
table(e)

barplot(table(e),xlab="",ylab="搔");#qXgO(ȏɂ͂Ȃ)
round(mean(e),3);                              #ρ@p.62,l.2
round(mean((e-mean(e))^2),3);               #U@p.62,l.3


#################|A\z̐stanR[h
Poisson<-'
data { 
  int<lower=0>  n;                  //f[^ 
  int<lower=0>  u[n];               //vf[^ 
}
parameters {
  real       lambda;                //ꐔ
}
model {
  for(i in 1:n)
    u[i] ~ poisson(lambda);         //|A\z (5.5)
}
generated quantities{
  int<lower=0>  uaste;              //\z 
    uaste = poisson_rng(lambda);    //|A\ (5.8)
}
';

par<-c("lambda","uaste")                #ꐔ
dataSet <-list(n=length(e),u=e) #

###########cmdstanrɂs
modfile <- write_stan_file(Poisson)                  #oꎞt@C
mod <- cmdstan_model(modfile)                      #RpC
csrfit <- mod$sample(data = dataSet,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit <- rstan::read_stan_csv(csrfit$output_files())   #stan`ւ̕ϊ

###########rstanɂs
#fit<-stan(model_code =Poisson, data=dataSet,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit,  file="./scrT/obje/stan_obje0501")
#load(file="./scrT/obje/stan_obje0501"); #\stan( )ōobject[h

ext<-extract(fit, par);               #̎o

##########\5.3 ꐔƐʂ̎㕪z̗v
sd<-sqrt(ext$lambda);                               #W΍
gqcal(ext$lambda,3);                                  #ώ㕪z
gqcal(sd   ,3);                                       #sd㕪z

###\5.2 hɂ锚eƎ\`FbN ̌㔼
round(table(ext$uaste)/length(ext$uaste),3);        #m
round(table(ext$uaste)/length(ext$uaste)*576,1);    #\l

#############5.2.2@ƌȃf[^
#####\5.4 uSvwv̎Ƃ̌ȎҐ
(<-c(0,1,2,0,0,1,2,0,2,0,1,0,0,1))

round(mean(),3);                #p.63,l.3
round(mean((-mean())^2),3); #p.63,l.3

par<-c("lambda","uaste")                #ꐔ
dataSet <-list(n=length(),u=) #

###########cmdstanrɂs
#                                RpCς "mod" gp
csrfit <- mod$sample(data = dataSet,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit <- rstan::read_stan_csv(csrfit$output_files())   #stan`ւ̕ϊ

###########rstanɂs
#fit<-stan(model_code =Poisson,data=dataSet,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit,  file="./scrT/obje/stan_obje0502")
#load(file="./scrT/obje/stan_obje0502"); #\stan( )ōobject[h

ext<-extract(fit, par);               #̎o

######\5.5 ꐔƐʂ̎㕪z̗v
sd<-sqrt(ext$lambda)
gqcal(ext$lambda,3)
gqcal(sd        ,3)

#####\5.6 Ȏ҂̎\`FbN
round(table(ext$uaste)/length(ext$uaste),3);        #\5.6
round(table(ext$uaste)/length(ext$uaste)*14,1)

#\5.7 ꐔƐʂ̎㕪z̗v    (\l̕z̔rj
\m2<-dpois(2,ext$lambda)
\m2<-dpois(2,ext$lambda)
\l2<-\m2*576
\l2<-\m2*14
gqcal(\m2,3)
gqcal(\l2,1)
gqcal(\m2,3)
gqcal(\l2,2)


############# 5.3   2̃|A\z̔r

####### \5.8 f`ʉۑɂE̕z
u1<-c(1,0,2,3,2,3,3,1,4,3,1,0,0,1,2,1,3,2,1,4,1,1,1,1,3,2,3,1,1,5)
u2<-c(1,3,2,7,4,4,2,1,0,2,1,2,1,0,1,5,5,3,4,2,1,3,1,1,1,2,3,1,1,3,0)
mean(u1);mean(u2)
table(u1);table(u2)

################# Q̃|A\z̐stanR[h
Poisson2<-'
data { 
  int<lower=0>  n1;                  //f[^ 
  int<lower=0>  n2;                  //f[^ 
  int<lower=0>  u1[n1];              //vf[^ 
  int<lower=0>  u2[n2];              //vf[^ 
}
parameters {
  real       lambda1;                //ꐔP
  real       lambda2;                //ꐔQ
}
model {
  for(i in 1:n1) u1[i] ~ poisson(lambda1); (5.10)
  for(i in 1:n2) u2[i] ~ poisson(lambda2); (5.10)
}
';
par<-c("lambda1","lambda2")                                #ꐔ
dataSet2 <-list(n1=length(u1),n2=length(u2),u1=u1,u2=u2) #

###########cmdstanrɂs
modfile2 <- write_stan_file(Poisson2)                #oꎞt@C
mod2 <- cmdstan_model(modfile2)                    #RpC
csrfit2 <- mod2$sample(data = dataSet2,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit2 <- rstan::read_stan_csv(csrfit2$output_files())   #stan`ւ̕ϊ

###########rstanɂs
#fit2<-stan(model_code =Poisson2, data=dataSet2,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit2,  file="./scrT/obje/stan_obje0503")
#load(file="./scrT/obje/stan_obje0503"); #\stan( )ōobject[h

ext2<-extract(fit2, par);               #̎o

#######\5.9  2Q̃|A\f̕ꐔ̎㕪z̗v
gqcal(ext2$lambda1,3)
gqcal(ext2$lambda2,3)

##### \5.10 ROPE łphcCROPE łȂphc
sequ<-seq(0,1.2,0.2);a<-ext2$lambda2;b<-ext2$lambda1
  phc01(sequ,a,b,cc="rope",byoga="no")
1-phc01(sequ,a,b,cc="rope",byoga="no")

#### \5.11 2 ̂ق傫Ƃphc
  phc01(sequ,a,b,cc="gtc", byoga="no")


####################5.4  |A\A

###### \5.12 f`ʉۑɂE
(X<-data.frame(
   s=c(1:15),
   E=c(6,4,3,2,2,2,1,1,1,0,0,2,1,0,0)))

##### }5.3 15 sɂE
plot(X[,1],X[,2],type="o",xlab="s",ylab="E")
  abline(a=coef(glm(X[,2]~X[,1]))[[1]],coef(glm(X[,2]~X[,1]))[[2]])

##### 5. 4. 1 wϊ   Ŝ琳̎ւ̕ϊ
##### }5.4 wϊexp( )
plot(exp,-2,2,xlab="a+bx",ylab="",main="", lwd=2.0,cex.lab=1.5)

####################|A\AstanR[h
Poisson_reg<-'
data { 
  int<lower=0>  n;                     //f[^ 
  int<lower=0>  y[n];                  //ϐ(vf[^)   
  vector[n]     X;                     //\ϐxNg   
}
parameters {
  real        a;                       //ؕ
  real        b;                       //ΉAW
}
transformed parameters {
  vector<lower=0>[n]  lambda;          //_ 
  for(i in 1:n)
    lambda[i] = exp(a + X[i]*b);       //(5.14), (5.19)
}
model {
  for(i in 1:n)
    y[i] ~ poisson(lambda[i]);         //|A\zf(5.13),(5.15)
}
generated quantities{
  int<lower=0>  yaste[n];               //\z 
  for(i in 1:n)
    yaste[i] = poisson_rng(lambda[i]); //|A\zf(5.20)
}
';

par<-c("a","b","lambda","yaste")                  #ꐔ
dataSetA <-list(n=nrow(X),y=X[,2], X=X[,1] )   #

###########cmdstanrɂs
modfileA <- write_stan_file(Poisson_reg)            #oꎞt@C
modA <- cmdstan_model(modfileA)                  #RpC
csrfitA <- modA$sample(data = dataSetA, chains=5,iter_sampling=20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitA <- rstan::read_stan_csv(csrfitA$output_files())   #stan`ւ̕ϊ

###########rstanɂs
#fitA<-stan(model_code =Poisson_reg, data=dataSetA,#f[^
#  pars=par, seed=1134, chains=1, warmup=1000,  iter=101000)
#save(fitA,  file="./scrT/obje/stan_obje0504")
#load(file="./scrT/obje/stan_obje0504"); #\stan( )ōobject[h

extA<-extract(fitA, par);               #̎o

#### ʁF\ϐPʕωƂ̕ꐔ̕ω
expb<-exp(extA$b);    (5.21)

###### \5.13 |A\Af̕ꐔEʓ̎㕪z̗v
gqcal(extA$a,3)
gqcal(extA$b,3)
gqcal(extA$lambda[,7],3)
gqcal(extA$yaste[,7],3)
gqcal(expb,3)

###### }5.5 Ẽ|A\A
lambda_i<-apply(extA$lambda,2,mean)
plot(X[,1],X[,2],type="o",xlab="s",ylab="E",xlim=c(1,15),ylim=c(0,6))
   par(new=T);                                        
plot(X[,1],lambda_i,type="l",xlab="",ylab="",lwd=2,xlim=c(1,15),ylim=c(0,6))


############# 5.5 ΐ`f
############# 5.5.1@x\
############# \5.14 LB ̐`ʂ𒲂ׂ钲̌
(u<-matrix(c(29,21,50,145),2,2,byrow=T))

##################\̕01Ex̕i2*2jstanR[h
Poisson_Cross01<-'
data { 
  int<lower=0>  u[2,2];                //ϐ(vf[^)   
}
parameters {
  real        mu;                      //S
  real        A1;                      //vA̎
  real        B1;                      //vB̎
  real        AB11;                    //ݍp
}
transformed parameters {
  matrix <lower=0>[2,2] lambda;          //_ 
  lambda[1,1] = exp(mu+ A1 + B1 + AB11);//(5.23), (5.24)
  lambda[2,1] = exp(mu- A1 + B1 - AB11);
  lambda[1,2] = exp(mu+ A1 - B1 - AB11);
  lambda[2,2] = exp(mu- A1 - B1 + AB11);
}
model {
  u[1,1] ~ poisson(lambda[1,1]);   //(5.25)
  u[2,1] ~ poisson(lambda[2,1]);   
  u[1,2] ~ poisson(lambda[1,2]);   
  u[2,2] ~ poisson(lambda[2,2]);   
}
';

par<-c("mu","A1","B1","AB11","lambda")  #ꐔ
dataSet\01<-list(u=u )             #

###########cmdstanrɂs
modfile\01 <- write_stan_file(Poisson_Cross01)  #oꎞt@C
mod\01 <- cmdstan_model(modfile\01)        #RpC
csrfit\01 <- mod\01$sample(data = dataSet\01,chains = 5,
  iter_sampling=20000, iter_warmup=1000, parallel_chains=5, seed=1234)
fit\01 <- rstan::read_stan_csv(csrfit\01$output_files()) #n`̕ϊ

###########rstanɂs
#fit\01<-stan(model_code =Poisson_Cross01,data=dataSet\01,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit\01,  file="./scrT/obje/stan_obje0505")
#load(file="./scrT/obje/stan_obje0505"); #\stan( )ōobject[h

ext\01<-extract(fit\01, par);               #̎o

##### \5.15 Lʂ͂̕̕ꐔEʂ̎㕪z̗v
gqcal(ext\01$mu)
gqcal(ext\01$A1)
gqcal(ext\01$B1)
gqcal(ext\01$AB11)


############# 5.5.2@䗦\

############# \5.16 ^C^jbN̏Eq̋]Ґ
(u<-matrix(c(4,118, 13,154, 106,422, 3,670),4,2,byrow=T));    #]
(n<-matrix(c(145,180, 106,179, 196,510, 23,862),4,2,byrow=T));#l

#################\̕02E䗦̕ia*bjstanR[h
Poisson_Cross02<-'
functions{
  vector zero_sum_vector(int a, vector m1A){//ʃ[a
    vector[a] muA;            
    for(i in 1:(a-1)){ muA[i]  = m1A[i];}   //a-1܂ł̓\bN
    muA[a]  = -sum(m1A);                    //aԖڂɁAa-1{
    return(muA);
  }
  matrix zero_sum_matrix(int a, int b, matrix m1AB){//ݍp[a
    vector [a-1] m1a;                       //saxNg
    vector [b-1] m1b;                       //axNg
    matrix [a,b] muAB;                      //^[s
    for(i in 1:(a-1)){ m1a[i]  = 0.0;}      //[NA
    for(j in 1:(b-1)){ m1b[j]  = 0.0;}      //[NA
    for(i in 1:(a-1)){ for(j in 1:(b-1)){muAB[i,j] =m1AB[i,j];}}//\bN
    for(i in 1:(a-1)){ for(j in 1:(b-1)){m1a[i] =m1a[i]+m1AB[i,j];}}//sa
    for(j in 1:(b-1)){ for(i in 1:(a-1)){m1b[j] =m1b[j]+m1AB[i,j];}}//a
    for(i in 1:(a-1)){muAB[i,b] = (-1)*m1a[i]; }    //bɍsa-1{
    for(j in 1:(b-1)){muAB[a,j] = (-1)*m1b[j]; }    //asɗa-1{
    muAB[a,b] = sum(m1a);  //asbvfɍvAӁF}CiXł͂Ȃ
    return(muAB);
  }
}
data { 
  int<lower=0>  a;                     //A
  int<lower=0>  b;                     //B
  int<lower=0>  u[a,b];                //ώ@x  
  int<lower=0>  n[a,b];                //s  
}
parameters {
  real                            mu;  //S
  vector                   [a-1] m1A;  //A1Ȃ
  vector                   [b-1] m1B;  //B1Ȃ
  matrix               [a-1,b-1] m1AB; //ݍp1Ȃ
}
transformed parameters {
  matrix <lower=0>[a,b] lambda;        //_ 
  vector                   [a] A;      //A
  vector                   [b] B;      //B
  matrix                 [a,b] AB;     //ABݍp
  matrix                 [a,b] p;      //䗦
  A =zero_sum_vector(a, m1A);          // (5.28)
  B =zero_sum_vector(b, m1B);          // (5.29)
  AB=zero_sum_matrix(a, b, m1AB);      // (5.30),(5.31)
  for(i in 1:a){
    for(j in 1:b){
      p[i,j] = exp(mu+ A[i] + B[j] + AB[i,j]);//(5.27), v
      lambda[i,j] = n[i,j]*p[i,j] ;           //(5.26), ɂ̍\
    }
  }
}
model {
  for(i in 1:a){
    for(j in 1:b){
      u[i,j] ~ poisson(lambda[i,j]);    //(5.26), {A\f
    }
  }
}
';

par<-c("mu","A","B","AB","p")                             #ꐔ
dataSet\02 <-list(a=nrow(u) ,b=ncol(u), u=u ,n=n )   #

###########cmdstanrɂs
modfile\02 <- write_stan_file(Poisson_Cross02)  #oꎞt@C
mod\02 <- cmdstan_model(modfile\02)        #RpC
csrfit\02 <- mod\02$sample(data = dataSet\02,chains = 5,
  iter_sampling=20000, iter_warmup=1000, parallel_chains=5, seed=1234)
fit\02 <- rstan::read_stan_csv(csrfit\02$output_files()) #n`̕ϊ

###########rstanɂs
#fit\02<-stan(model_code =Poisson_Cross02,data=dataSet\02,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit\02,  file="./scrT/obje/stan_obje0506")
#load(file="./scrT/obje/stan_obje0506"); #\stan( )ōobject[h

ext\02<-extract(fit\02, par);               #̎o

##\5.17 ^C^jbN̋]҂͂̕̕ꐔEʂ̎㕪z̗v
print(fit\02,digits_summary=3,prob=prob)

###\5.18 Eݍp̌ʂ0 傫() m
for (i in 1:4){                                       #\5.18 
  print(round(mean(ext\02$A[,i]>0),3))
  print(round(1-mean(ext\02$A[,i]>0),3))
}
  print(round(mean(ext\02$B[,1]>0),3))           #\5.18 
  print(round(1-mean(ext\02$B[,1]>0),3))
for (i in 1:4){
  print(round(mean(ext\02$AB[,i,1]>0),3))        #\5.18 E
  print(round(1-mean(ext\02$AB[,i,1]>0),3))
}

###\5.19 s̔䗦̔䗦傫phc
phc02(0,cbind(ext\02$p[,1,],ext\02$p[,2,],
              ext\02$p[,3,],ext\02$p[,4,]))


#################Kۑ
p_11<-ext\02$p[,1,1]
p_31<-ext\02$p[,3,1]
gqcal(p_11)
gqcal(p_31)
phc01(seq(0,1,0.01),p_31-p_11,cc="gtc",byoga="yes",xlab="S̃XN")
phc01(seq(0.38,0.48,0.01),p_31-p_11,cc="gtc",byoga="no")

phc01(seq(1,30,1),p_31/p_11,cc="gtc",byoga="yes",xlab="S̃XN")
phc01(seq(5,15,1),p_31/p_11,cc="gtc",byoga="no")

