##########Ú@̕zɂƗPv̐
# Working directory 'toyoda' ł邱Ƃ̊mF
(n_wd<-getwd())                #working directory(wd)̊mF
(setwd('./scrT'))              #wd̈ړ
source('../myfunc/myfunc.R')   #֐̓ǂݍ
(setwd(n_wd))                  #wd߂
library(rstan)                 #pbP[WrstaňĂяo
library(cmdstanr)              #pbP[WcmdstanřĂяo
library(posterior)             #pbP[WposteriořĂяo
prob<-c(0.025, 0.05, 0.5, 0.95, 0.975) #m_̒`

###################6.1 ΐKz

#####}6.1 ΐKz̊mx֐
par(mfrow=c(1,2))
for (i in c(0.5,1.0,1.8)){
  d1<-function(x){dlnorm(x,0,i)}
  curve(d1,0,3,ylim=c(0,1.2),xlab="",ylab="",cex.axis=2.0)
  par(new=T)
}
  text(1.3,0.8,"=0.5",cex=2)
  text(0.8,0.5,"=1.0",cex=2)
  text(0.4,1.1,"=1.8",cex=2)
  text(2.3,0.8,"=0",cex=2.5);                      #1ڂ܂
  par(new=F)
for (i in c(0.0,0.2,0.4,0.6)){
  d1<-function(x){dlnorm(x,i,1)}
  curve(d1,0,4,ylim=c(0,0.7),xlab="",ylab="",cex.axis=2.0)
  par(new=T)
}
  text(1.0,0.6,"=0.0",cex=2)
  text(1.2,0.5,"=0.2",cex=2)
  text(1.4,0.4,"=0.4",cex=2)
  text(0.8,0.3,"=0.6",cex=2)
  text(3.0,0.50,"=1.0",cex=2.5)
  par(new=F)
par(mfrow=c(1,1));                                    #}6.1܂
#dev.copy2eps(file="z0501.eps",family="Japan1")

###################6.1.1 l

### }6.2 Wc̔N̕z
hist(rlnorm(10000,15.3,0.5)/10000,xlim=c(0,2000),breaks=30,
  xlab="~",ylab="",cex.axis=2.0,cex.lab=2.0)

### p.77  p.78 㕔
exp(15.3+0.5*0.5^2);                                  #   (6.3)
exp(15.3);                                            #l (6.5)
exp(15.3-0.5^2);                                      #ŕpl (6.6)
qlnorm(0.95, 15.3,0.5);                               #_
qlnorm(0.99, 15.3,0.5)
qlnorm(0.999,15.3,0.5)

###################6.1.2 ΐKz̐
###################\6.1@EI 30 l̔N(~)
x1<-c(367, 1611, 263, 405, 754, 415, 837, 341, 396, 342,
      282,  296, 886, 412, 572, 471, 781, 531, 757, 723,
      870,  933, 392, 612, 394, 343, 372, 747, 280, 941)

#####################ΐKz̐stanR[h
lognormal01<-'
data { 
  int<lower=0>   n;                 //f[^ 
  real<lower=0>  x[n];              //f[^ 
}
parameters {
  real          mu;                 //ꐔ (6.1)
  real<lower=0> sigma;              //ꐔ (6.1)
}
model {
  for(i in 1:n)
    x[i] ~ lognormal(mu,sigma);     //ΐKz (6.2), (6.8)
}
generated quantities{
  real       heikin;                //ϒl
  real       tyuouti;               //l
  real       saihin;                //ŕpl
  real       sigma0;                //W΍
  heikin = exp(mu+0.5*sigma^2);                     // (6.3)
  tyuouti= exp(mu);                                 // (6.5)
  saihin = exp(mu-sigma^2);                         // (6.6)
  sigma0=sqrt(exp(2*mu+sigma^2)*(exp(sigma^2)-1));  // (6.4)
}
';

par<-c("mu","sigma","heikin","tyuouti","saihin","sigma0")    #ꐔ
dataSet1 <-list(n=length(x1),x=x1)                         #

###########cmdstanrɂs
modfile1 <- write_stan_file(lognormal01)             #oꎞt@C
mod1 <- cmdstan_model(modfile1)                   #RpC
csrfit1 <- mod1$sample(data = dataSet1,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit1 <- rstan::read_stan_csv(csrfit1$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit1<-stan(model_code =lognormal01,data=dataSet1,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit1,  file="./scrT/obje/stan_obje0601")
#load(file="./scrT/obje/stan_obje0601"); #\stan( )ōobject[h

ext1<-extract(fit1, par);               #̎o

###### \6.2 EI ̕ꐔƐʂ̎㕪z̗v
gqcal(ext1$mu)
gqcal(ext1$sigma)
gqcal(ext1$heikin ,0)
gqcal(ext1$tyuouti,0)
gqcal(ext1$saihin ,0)
gqcal(ext1$sigma0 ,0)

##################6.1.3  2̑ΐKz̔r
##################\6.3 EII 30 l̔N(~)
x2<-c(697, 681, 330, 176,  307, 1668, 641, 1150, 301, 365,
     1033, 373, 836, 367,  265,  217, 941,  278, 504, 299,
      865, 504, 790, 273, 2292,  385, 277,  622, 475,1205)

###################Q̑ΐKz̐stanR[h
lognormal02<-'
data { 
  int<lower=0>  n1;                  //f[^ I
  int<lower=0>  n2;                  //f[^ II
  real<lower=0>  x1[n1];             //f[^ I
  real<lower=0>  x2[n2];             //f[^ II 
}
parameters {
  real             mu[2];            //ꐔ1,2 (6.8)
  real<lower=0> sigma[2];            //ꐔ1,2 (6.8)
}
transformed parameters {
}
model {
  for(i in 1:n1)  x1[i] ~ lognormal(mu[1],sigma[1]); //ΐKz
  for(i in 1:n2)  x2[i] ~ lognormal(mu[2],sigma[2]); //(6.8)
}
generated quantities{
  real       heikin[2];             //ϒl2
  real       tyuouti[2];            //l2
  real       saihin[2];             //ŕpl2
  real       sigma0[2];             //W΍2
  heikin[1] = exp(mu[1]+0.5*sigma[1]^2);                      // (6.3) I
  tyuouti[1]= exp(mu[1]);                                     // (6.5) I
  saihin[1] = exp(mu[1]-sigma[1]^2);                          // (6.6) I
  sigma0[1]=sqrt(exp(2*mu[1]+sigma[1]^2)*(exp(sigma[1]^2)-1));// (6.4) I
  heikin[2] = exp(mu[2]+0.5*sigma[2]^2);                      // (6.3) II
  tyuouti[2]= exp(mu[2]);                                     // (6.5) II
  saihin[2] = exp(mu[2]-sigma[2]^2);                          // (6.6) II
  sigma0[2]=sqrt(exp(2*mu[2]+sigma[2]^2)*(exp(sigma[2]^2)-1));// (6.4) II
}
';

par<-c("mu","sigma","heikin","tyuouti","saihin","sigma0")  #ꐔ
dataSet2 <-list(n1=length(x1),n2=length(x2),x1=x1,x2=x2) #

###########cmdstanrɂs
modfile2 <- write_stan_file(lognormal02)             #oꎞt@C
mod2 <- cmdstan_model(modfile2)                   #RpC
csrfit2 <- mod2$sample(data = dataSet2,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit2 <- rstan::read_stan_csv(csrfit2$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit2<-stan(model_code =lognormal02,data=dataSet2,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit2, file="./scrT/obje/stan_obje0602")
#load(file="./scrT/obje/stan_obje0602"); #\stan( )ōobject[h

ext2<-extract(fit2, par);               #̎o

######\6.4 EII ̕ꐔƐʂ̎㕪z̗v
gqcal(ext2$mu[,2])
gqcal(ext2$sigma[,2])
gqcal(ext2$heikin[,2] ,0)
gqcal(ext2$tyuouti[,2],0)
gqcal(ext2$saihin[,2] ,0)
gqcal(ext2$sigma0[,2] ,0)

#\6.5  2̑ΐKz̈ʒu̍̎㕪z̗v  ϒl l ŕpl̍
gqcal(ext2$heikin[,2]-ext2$heikin[,1])
gqcal(ext2$tyuouti[,2]-ext2$tyuouti[,1])
gqcal(ext2$saihin[,2]-ext2$saihin[,1])

######\6.6 ϒlClCŕplɍ̂phc
sequ66<-c(0,10,20,30)
phc01(sequ66,ext2$heikin[,2] ,ext2$heikin[,1] ,cc="gtc",byoga="no")
phc01(sequ66,ext2$tyuouti[,2],ext2$tyuouti[,1],cc="gtc",byoga="no")
phc01(sequ66,ext2$saihin[,1] ,ext2$saihin[,2] ,cc="gtc",byoga="no")

######\6.7 ϒlClCŕplROPE łphc
sequ67<-c(0,50,100,120)
phc01(sequ67,ext2$heikin[,2] ,ext2$heikin[,1] ,cc="rope",byoga="no")
phc01(sequ67,ext2$tyuouti[,2],ext2$tyuouti[,1],cc="rope",byoga="no")
phc01(sequ67,ext2$saihin[,1] ,ext2$saihin[,2] ,cc="rope",byoga="no")


########################6.2  ΐKzɂ1v
#####\6.9 f`ʉۑ̌QƂ15 sڂ̃^CƈE
(f`01<-read.csv("./scrT/dat/f`01.csv", header = TRUE))

#####}6.3 f`ʉۑɂQƂ̃^C(b)
boxplot(f`01$time~f`01$group,             #}6.3
     xlab="group", ylab="",cex.axis=2.0,cex.lab=2.0)
#dev.copy2eps(file="z0503.eps",family="Japan1")
tapply(f`01$time,f`01$group,mean); #QƂ̕σ^C p.82


########################ΐKzɂ1vstanR[h
one_factor_lognormal<-'
data { 
  int<lower=0>  n;                    //Sf[^ 
  int<lower=0>  J;                    //Q
  vector[n]     y;                    //ϐ 
  int<lower=0>  k[n];                 //ޕϐ 
}
parameters {
  vector[J]            mu;            //eQmu     J
  vector<lower=0>[J]   sigma;         //eQsigma  J
}
model {
  for(i in 1:n)
    y[i] ~ lognormal(mu[k[i]], sigma[k[i]]);  //(6.14)
}
generated quantities{
  vector[J]            mu0;            //eQ̕     J
  vector[J]            medi0;          //eQ̒l   J
  vector[J]            mode0;          //eQ̍ŕpl   J
  vector<lower=0>[J]   sigma0;         //eQ̕W΍ J
  for(j in 1:J){
    mu0[j]   =exp(mu[j]+(0.5*sigma[j]^2));                      // (6.3)
    medi0[j] =exp(mu[j]);                                       // (6.5)
    mode0[j] =exp(mu[j]-sigma[j]^2);                            // (6.6)
    sigma0[j]=sqrt(exp(2*mu[j]+sigma[j]^2)*(exp(sigma[j]^2)-1));// (6.4)
  }
}
';
par<-c("mu","sigma","mu0","medi0","mode0","sigma0")               #ꐔ
dataSetlogn <-list(n=length(f`01$time), 
  J=max(f`01$group),y=f`01$time, k=f`01$group ) #

###########cmdstanrɂs
modfilelogn <- write_stan_file(one_factor_lognormal)    #oꎞt@C
modlogn <- cmdstan_model(modfilelogn)                   #RpC
csrfitlogn <- modlogn$sample(data=dataSetlogn,chains=5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitlogn <- rstan::read_stan_csv(csrfitlogn$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitlogn<-stan(model_code =one_factor_lognormal,data=dataSet02,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitlogn, file="./scrT/obje/stan_obje0603")
#load(file="./scrT/obje/stan_obje0603"); #\stan( )ōobject[h

extlogn<-extract(fitlogn, par);               #̎o

##### \6.10 1 vΐKzf̕ꐔ̎㕪z
print(fitlogn,digits_summary=3,prob=prob)

##### }6.4 f`ʉۑEQƂ̃^C̕z(ΐKz)
lognor01<-function(x){dlnorm(x,3.153, 0.685)}
lognor02<-function(x){dlnorm(x,2.981, 0.449)}
lognor03<-function(x){dlnorm(x,2.822, 0.488)}
curve(lognor01,0,80,ylim=c(0,0.055),xlab="",ylab="",lty=1,lwd=2)
par(new=T)
curve(lognor02,0,80,ylim=c(0,0.055),xlab="",ylab="",lty=2,lwd=2)
par(new=T)
curve(lognor03,0,80,ylim=c(0,0.055),xlab="time",
  ylab="mx",lty=3,lwd=2)
text(60,0.01,"1Q",cex=1.6)
text(30,0.04,"2Q",cex=1.6)
text( 5,0.05,"3Q",cex=1.6)                       #}6.4܂

#\6.11 sj ̐̕ςj̐̕ς傫m
phc02(0,extlogn$mu0)

#xeQ񗘂Q蒷A@񗘂QQ蒷m
round(mean((extlogn$mu0[,1]>extlogn$mu0[,2])&
           (extlogn$mu0[,2]>extlogn$mu0[,3])),3)    #(6.17),(6.18)


########################6. 3 |A\zɂ1 v
#####\6.9 f`ʉۑ̌QƂ15 sڂ̃^CƈE
(f`01<-read.csv("./scrT/dat/f`01.csv", header = TRUE))

##### }6.5 f`ʉۑɂQ EƂ̐l̖_Ot
barplot(table(f`01$E,f`01$group),
        xlab="QƂ̈E",ylab="l",beside=T,legend.text=0:5 )

#QƂ̕ψE@p.84,bl.8
tapply(f`01$E,f`01$group,mean)


############################|A\zɂ1vstanR[h
one_factor_Poisson<-'
data { 
  int<lower=0>  n;                      //Sf[^ 
  int<lower=0>  J;                      //Q
  int<lower=0>  y[n];                   //ϐ   
  int<lower=0>  k[n];                   //ޕϐ 
}
parameters {
  vector<lower=0>[J] lambda;            //eQlambda J
}
model {
  for(i in 1:n)
      y[i] ~ poisson(lambda[k[i]]);     //(6.19)
}
';

par<-c("lambda")                                                   #ꐔ
dataSetpo <-list(n=length(f`01$E),
   J=max(f`01$group),y=f`01$E, k=f`01$group ) #

###########cmdstanrɂs
modfilepo <- write_stan_file(one_factor_Poisson)    #oꎞt@C
modpo <- cmdstan_model(modfilepo)                   #RpC
csrfitpo <- modpo$sample(data = dataSetpo,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitpo <- rstan::read_stan_csv(csrfitpo$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitpo<-stan(model_code =one_factor_Poisson,data=dataSet02,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitpo, file="./scrT/obje/stan_obje0604")
#load(file="./scrT/obje/stan_obje0604"); #\stan( )ōobject[h

extpo<-extract(fitpo, par);               #̎o

##### \6.12 1 v|A\zf̕ꐔ̎㕪z
print(fitpo,digits_summary=3,prob=prob)

##### }6.6 f`ʎEQƂ̈E̕z(|A\z)
x<-0:5
plot(x,dpois(x,1.100),type="o",ylim=c(0,0.7),xlab="",ylab="",lty=1,lwd=2)
par(new=T)
plot(x,dpois(x,0.666),type="o",ylim=c(0,0.7),xlab="",ylab="",lty=2,lwd=2)
par(new=T)
plot(x,dpois(x,0.401),type="o",ylim=c(0,0.7),
  xlab="E",ylab="m",lty=3,lwd=2)
  legend(3,0.6,paste("",1:3,"Q"),lty=1:3)          #}6.6܂

##\6.13 s j ̐̕ς j' ̐̕ς傫m
phc02(0,extpo$lambda)

##xeQ񗘂Q蒷A@񗘂QQ蒷m
round(mean((extpo$lambda[,1]>extpo$lambda[,2])
          &(extpo$lambda[,2]>extpo$lambda[,3])),3)    #(6.20)


###################6.4   2zɂ1 v
####\6.14 biɊւPɂQƂ̊{ꐔƕ\
(bi<-read.csv("./scrT/dat/bi.csv",header = TRUE))

####}6.7 biPɂQƂ̕\
boxplot(bi$\/bi${ꐔ~bi$group,  
  xlab="group", ylab="", cex.axis=2.0,cex.lab=2.0)
#dev.copy2eps(file="z0507.eps",family="Japan1")

#####QƂ̕\̕ρ@p.86,bl.7
round(tapply(bi$\/bi${ꐔ,bi$group,mean),3)

#############################2zɂ1vstanR[h
one_factor_binom<-'
data { 
  int<lower=0>  n;                      //Sf[^ 
  int<lower=0>  J;                      //Q
  int<lower=0>  y[n];                   //ϐ   
  int<lower=0>  m[n];                   //s  
  int<lower=0>  k[n];                   //ޕϐ 
}
parameters {
  vector<lower=0,upper=1>[J] p;         //eQ̊m J
}
model {
  for(i in 1:n)
    y[i] ~ binomial(m[i],p[k[i]]);      //(6.21)
}
';

par<-c("p")                                                       #ꐔ
dataSetbi <-list(n=length(bi$\),J=max(bi$group),
   y=bi$\, m=bi${ꐔ, k=bi$group )     #

###########cmdstanrɂs
modfilebi <- write_stan_file(one_factor_binom)      #oꎞt@C
modbi <- cmdstan_model(modfilebi)                   #RpC
csrfitbi <- modbi$sample(data = dataSetbi,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitbi <- rstan::read_stan_csv(csrfitbi$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitbi<-stan(model_code =one_factor_binom,data=dataSetbi, 
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitbi, file="./scrT/obje/stan_obje0605")
#load(file="./scrT/obje/stan_obje0605"); #\stan( )ōobject[h

extbi<-extract(fitbi, par);               #̎o

###### \6.15 1 v2 zf̕ꐔ̎㕪z
print(fitbi,digits_summary=3,prob=prob)

##### }6.8 EAP lɂeQ2 z
x<-0:10
plot(x,dbinom(x,10,0.338),type="o",ylim=c(0,0.3),xlab="",ylab="",lty=1,lwd=2)
par(new=T)
plot(x,dbinom(x,10,0.510),type="o",ylim=c(0,0.3),xlab="",ylab="",lty=2,lwd=2)
par(new=T)
plot(x,dbinom(x,10,0.613),type="o",ylim=c(0,0.3),
  xlab="\",ylab="m",lty=3,lwd=2)
legend(8,0.27,paste("",1:3,"Q"),lty=1:3);          #}6.8܂


###\6.16 s j ̐̔䗦 j' ̐̔䗦傫phc
phc02(0,extbi$p)

#A肪m(C ɑΉ@ȏɂ͂Ȃ)
round(mean((extbi$p[,1]<extbi$p[,2])&(extbi$p[,2]<extbi$p[,3])),3)


############6. 5 Kzɂ1 v(ϗʃf)
###\6.17 100m ڂ̑I6 10 ̐
(M100<-read.csv("./scrT/dat/M100.csv", header = TRUE))

####}6.9 100m ڂ̑I6 10 ̃^C̃{bNXvbg
boxplot(M100$time~M100$I, xlab="Iԍ", ylab="time");#}6.9
#dev.copy2eps(file="z0501.eps",family='Japan1')

##############KzɂPv(ϗʃf)stanR[h
one_factor_normal<-'
data { 
  int<lower=0>  n;                     //Sf[^ 
  int<lower=0>  J;                     //Q
  vector[n]     y;                     //ϐ   
  int<lower=0>  k[n];                  //ޕϐ 
}
parameters {
  vector[J]     mu;                    //eQ̕ J
  real<lower=0> sigma;                 //덷SD
  real<lower=0> s_mu;                  //vSD
  real          mu0;                   //S
}
model {
    y ~ normal(mu[k], sigma);          //(6.24)
    mu~ normal(mu0, s_mu);             //(6.25)
}
generated quantities{
  real<lower=0,upper=1> eta2;           //
  eta2 = (s_mu^2)/((s_mu^2)+(sigma^2)); //(6.27)
}
';

par<-c("mu","sigma","s_mu","mu0","eta2")     #ꐔ
dataSetnorm <-list(n=length(M100$time), 
   J=max(M100$I),y=M100$time, k=M100$I ) #

###########cmdstanrɂs
modfilenorm <- write_stan_file(one_factor_normal)       #oꎞt@C
modnorm <- cmdstan_model(modfilenorm)                   #RpC
csrfitnorm <- modnorm$sample(data=dataSetnorm,chains=5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitnorm <- rstan::read_stan_csv(csrfitnorm$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitnorm<-stan(model_code =one_factor_normal,data=dataSetnorm,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitnorm, file="./scrT/obje/stan_obje0606")
#load(file="./scrT/obje/stan_obje0606"); #\stan( )ōobject[h

extnorm<-extract(fitnorm, par);               #̎o

##### \6.18 ϗʃf̕ꐔ̎㕪z̗v
print(fitnorm,digits_summary=3,prob=prob)

##### \6.19 s̑I̕ς̑I̕ς傫m
phc02(0,extnorm$mu)

#################Kۑ
###  1.

#
#     ͊
#

###  2.

#
#     ͊
#

###  3.

#
#     ͊
#

###  4.
c1<-c(0,1,2)
c2<-c(0,1,2)
rengen_01<-matrix(0,length(c1),length(c2));
ii<-0;
for (i in c1){
  ii<-ii+1
  jj<-0
  for (j in c2){
    jj<-jj+1
    rengen_01[ii,jj]<-mean((i < heikin_sa12 )&
                           (j < heikin_sa23 ) )
  }
}
rownames(rengen_01)<-c1
colnames(rengen_01)<-c2
round(rengen_01,3)

###  5.
lambda_sa12 <- extpo$lambda[,1]-extpo$lambda[,2]
lambda_sa23 <- extpo$lambda[,2]-extpo$lambda[,3]
phc01(seq(0,1,0.05),lambda_sa12,cc="gtc",byoga="yes",
      xlab="xeQƔ񗘂Q̍")
phc01(seq(0,1,0.05),lambda_sa23,cc="gtc",byoga="yes",
      xlab="񗘂QƗQ̍")
phc01(seq(0,0.3,0.05),lambda_sa12,cc="gtc",byoga="no")
phc01(seq(0,0.2,0.05),lambda_sa23,cc="gtc",byoga="no")


###  6.
c1<-c(0,0.1,0.2)
c2<-c(0,0.1,0.2)
rengen_02<-matrix(0,length(c1),length(c2));
ii<-0;
for (i in c1){
  ii<-ii+1
  jj<-0
  for (j in c2){
    jj<-jj+1
    rengen_02[ii,jj]<-mean((i < lambda_sa12 )&
                           (j < lambda_sa23 ) )
  }
}
rownames(rengen_02)<-c1
colnames(rengen_02)<-c2
round(rengen_02,3)

###  7.
hiritu_sa21 <- extbi$p[,2]-extbi$p[,1]
hiritu_sa32 <- extbi$p[,3]-extbi$p[,2]
phc01(seq(0,0.3,0.01),hiritu_sa21,cc="gtc",byoga="yes",
      xlab="21̍")
phc01(seq(0,0.2,0.01),hiritu_sa32,cc="gtc",byoga="yes",
      xlab="32̍")
phc01(seq(0,0.15,0.03),hiritu_sa21,cc="gtc",byoga="no")
phc01(seq(0,0.1,0.02),hiritu_sa32,cc="gtc",byoga="no")


###  8.
eta2<-extnorm$eta2
phc01(seq(0.1,0.8,0.05),eta2,cc="gtc",byoga="yes",
      xlab="")
phc01(seq(0,3,0.02),extnorm$mu[,1]-extnorm$mu[,2],cc="gtc",byoga="yes",
      xlab="I1ƑI2̍")
phc01(seq(0,0.15,0.03),eta2,cc="gtc",byoga="no")
phc01(seq(0,1,0.2),extnorm$mu[,1]-extnorm$mu[,2],cc="gtc",byoga="no")


###############################f`ʎf[^
#^C
xtime<-c(40.03,35.04,32.38,23.25,24.45,
      30.66,32.26,21.18,25.53,37.66,
      22.51,33.46,14.87,23.52,26.63,
      35.27,54.38,17.59,39.75,29.63,
      36.72,26.77,24.67,61.77,31.28,
      27.83,27.78,33.15)
time<-c(21.39,13.89,24.76,24.20,17.77,
      24.90,24.15,13.56,21.86,17.58,
      34.03,20.41,19.09,27.90,29.91,
      20.88,26.44,21.29,10.71,21.92,
      17.09,31.98,31.18,18.37,16.53,
      27.40,26.03)
time<-c(08.63,12.40,15.11,23.68,16.28,
      29.56,25.40,12.53,19.00,21.59,
      21.93,23.03,17.09,11.37,23.84,
      22.03,18.98,12.40,25.77,12.62,
      13.78,10.43,24.49,34.28,13.74,
      18.22,18.56,21.22)

#E
xfreq<-c(1,1,0,2,1,0,2,2,2,2,0,4,2,0,1,2,2,1,6,5,1,2,3,1,0,1,2,2)
freq<-c(2,0,0,0,1,2,0,3,0,1,2,1,0,0,1,0,1,2,0,0,2,1,1,0,2,4,1)
freq<-c(0,1,0,1,1,0,1,1,0,1,0,0,1,2,0,1,0,0,0,0,0,0,0,0,0,0,1,0)
