############7́@U/XXRA
# Working directory 'toyoda' ł邱Ƃ̊mF
(n_wd<-getwd())                #working directory(wd)̊mF
(setwd('./scrT'))              #wd̈ړ
source('../myfunc/myfunc.R')   #֐̓ǂݍ
(setwd(n_wd))                  #wd߂
library(rstan)                 #pbP[WrstaňĂяo
library(cmdstanr)              #pbP[WcmdstanřĂяo
library(posterior)             #pbP[WposteriořĂяo
library(pROC)
library(Matching)
prob<-c(0.025, 0.05, 0.5, 0.95, 0.975) #m_̒`


####################### 7͂ŗp֐
#2Q2ϗʃf[^̎Uz}pchςĕ`֐
plot2g<-function(y,x,a,ba=5,xlab="pre test"){
  plot(x,y,pch=ifelse(a-1,1,16),xlab=xlab,ylab="post test",
     cex.lab=1.5,cex.axis=1.5,xlim=c(min(x)-ba,max(x)+ba),
     ylim=c(min(y)-ba,max(y)+ba))
}
#2Q̎Uz}2{̌Xʂ̉A`֐
plot2gequ<-function(y,x,a,ext,ba=5,xlab="pre test"){
  plot(x,y,pch=ifelse(a-1,1,16),xlab=xlab,ylab="post test",
     cex.lab=1.5,cex.axis=1.5,xlim=c(min(x)-ba,max(x)+ba),
     ylim=c(min(y)-ba,max(y)+ba))
  abline(mean(ext$a[,1]),mean(ext$b))     
  abline(mean(ext$a[,2]),mean(ext$b))     
}
#W{U
bunsan<-function(x){mean((x-mean(x))^2)}

#Uz}ɌẌقȂ2{̉A`֐
plot2gdef<-function(y,x,a,ext,ba=3){
  plot(x,y,pch=ifelse(a-1,1,16),xlab="pre test",ylab="post test",
     cex.lab=1.5,cex.axis=1.5,xlim=c(min(x)-ba,max(x)+ba),
     ylim=c(min(y)-ba,max(y)+ba))
  abline(mean(ext$a[,1]),mean(ext$b[,1]))     
  abline(mean(ext$a[,2]),mean(ext$b[,2]))     
}
#ẌقȂ2{̉A̗\l̍EAP95mMԂ`֐}
plot2gdefdef<-function(x,ext){
  leng=30
  xlabe<-seq(min(x),max(x),length=leng)
  yhat_sa<-matrix(0,nrow(ext$a),leng)
  yhat_sa_HL<-matrix(0,leng,2)
  for (i in (1:leng)){
    yhat_sa[,i]<-ext$a[,1]-ext$a[,2]+(ext$b[,1]-ext$b[,2])*xlabe[i]}
  for (i in (1:leng)){
    yhat_sa_HL[i,]<-quantile(yhat_sa[,i],prob=c(0.025,0.975))}
  plot(xlabe,colMeans(yhat_sa),ylim=c(min(yhat_sa_HL),max(yhat_sa_HL)),
    type="l",ylab="",xlab="",lwd=2.0)
  abline(a=0,b=0,lwd=2.0)
  par(new=T)
  plot(xlabe,yhat_sa_HL[,1],ylim=c(min(yhat_sa_HL),max(yhat_sa_HL)),
    type="l",ylab="",xlab="",lty=2,lwd=2.0)
  par(new=T)
  plot(xlabe,yhat_sa_HL[,2],ylim=c(min(yhat_sa_HL),max(yhat_sa_HL)),
    type="l",ylab="post̗\l̍",xlab="prel",lty=2,lwd=2.0)
}
#######################V͂ŗp֐܂

##### 7.2 XʂU

##### 7. 2. 1 uf[^1v̕

##### \7.1 uf[^1v̕ϒl
wK01<-read.csv("./scrT/dat/wK01.csv", header = TRUE)
round(tapply(wK01$post,wK01$subject,mean),1)
round(tapply(wK01$pre ,wK01$subject,mean),1)

##### }7.1 uf[^1v̎Uz}
plot2g(y=wK01$post,x=wK01$pre,a=wK01$subject,ba=3)
#dev.copy2eps(file="z0701.eps",family='Japan1')

#############################U(Xʂ̃f)stanR[h
ANCOVAequ<-'
data { 
  int<lower=0>  n;                     //f[^ 
  vector[n]     y;                     //ϐ   
  vector[n]     x;                     //\ϐ   
  int<lower=0,upper=2> k[n];           //ޕϐ 
}
parameters {
  vector[2]   a;                       //ؕ
  real        b;                       //AW 
  real<lower=0> sigma;                 //덷W΍
}
transformed parameters {
  vector[n]  yhat;                     //\l yhat  
  for(i in 1:n)
    yhat[i] = a[k[i]] + x[i]*b;        //(7.4),(7.5)
}
model {
    y ~ normal(yhat, sigma);           //(7.1),(7.2),(7.3)
}
';

par<-c("a","b","sigma");                                                  #ꐔ
dataSetequ01<-list(n=nrow(wK01),y=wK01[,2],x=wK01[,1],k=wK01[,3]);#

###########cmdstanrɂs
modfileequ01 <- write_stan_file(ANCOVAequ)             #oꎞt@C
modequ01 <- cmdstan_model(modfileequ01)                #RpC
csrfitequ01<-modequ01$sample(data=dataSetequ01,chains=5,iter_sampling=20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitequ01 <- rstan::read_stan_csv(csrfitequ01$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitequ01<-stan(model_code =ANCOVAequ,pars=par,data=dataSetequ01,
#  seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitequ01,  file="./scrT/obje/stan_obje0701")
#load(file="./scrT/obje/stan_obje0701"); #\stan( )ōobject[h

extequ01<-extract(fitequ01, par);               #̎o

##### \7.2 uf[^1v̌Xʂf̕ꐔ̎㕪z̗v
gqcal(extequ01$a[,1],2)
gqcal(extequ01$a[,2],2)
gqcal(extequ01$b    ,2)
gqcal(extequ01$sigma,2)

##### }7.2 uf[^1v̉A(X)
plot2gequ(y=wK01$post,x=wK01$pre,
          a=wK01$subject,ext=extequ01,ba=3);
#dev.copy2eps(file="z0702.eps",family='Japan1')

a_sa01<-extequ01$a[,1]-extequ01$a[,2];                #ؕЂ̍̎㕪z
gqcal(a_sa01,1);                                      #p.96,l.6

##### }7.3 uf[^1v̐ؕЂ̍̎㕪z
hist(a_sa01,breaks=100,ylab="",xlab="ؕЂ̍",main="",cex.lab=2,cex.axis=1.5)
#dev.copy2eps(file="z0703.eps",family='Japan1')


####### 7.2.2 uf[^2v̕
##### \7.3 uf[^2v̕ϒl
wK02<-read.csv("./scrT/dat/wK02.csv", header = TRUE)
round(tapply(wK02$post,wK02$subject,mean),1)
round(tapply(wK02$pre,wK02$subject,mean),1)

##### }7.4 uf[^2v̎Uz}
plot2g(y=wK02$post,x=wK02$pre,a=wK02$subject,ba=3)
#dev.copy2eps(file="z0704.eps",family='Japan1')

par<-c("a","b","sigma");                                                  #ꐔ
dataSetequ02<-list(n=nrow(wK02),y=wK02[,2],x=wK02[,1],k=wK02[,3]);#

###########cmdstanrɂs
### RpCʂ (Xʂ̃f)'modequ01'𗘗p
csrfitequ02<-modequ01$sample(data=dataSetequ02,chains=5,iter_sampling=20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitequ02 <- rstan::read_stan_csv(csrfitequ02$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitequ02<-stan(model_code =ANCOVAequ,pars=par,
#  data=list,
#  seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitequ02,  file="./scrT/obje/stan_obje0702")
#load(file="./scrT/obje/stan_obje0702"); #\stan( )ōobject[h

extequ02<-extract(fitequ02, par);               #̎o

##### \7.4 uf[^2v̌Xʂf̕ꐔ̎㕪z̗v
gqcal(extequ02$a[,1],2)
gqcal(extequ02$a[,2],2)
gqcal(extequ02$b    ,2)
gqcal(extequ02$sigma,2)

##### }7.5 uf[^2v̉A(X)
plot2gequ(y=wK02$post,x=wK02$pre,a=wK02$subject,ext=extequ02,ba=3)
#dev.copy2eps(file="z0705.eps",family='Japan1')

a_sa02<-extequ02$a[,1]-extequ02$a[,2];                   #ؕЂ̍̎㕪z
gqcal(a_sa02,1);                                         #p.97,bl.7

##### }7.6 uf[^2v̐ؕЂ̍̎㕪z
hist(a_sa02,breaks=100,ylab="",xlab="ؕЂ̍",   
     main="",cex.lab=2,cex.axis=1.5)
#dev.copy2eps(file="z0706.eps",family='Japan1')

mean(abs(a_sa02)<1.0);                                #ROPEłƂphc
mean(abs(a_sa02)<1.5);                                #p.97,bl.4

########## 7. 3 XقȂ鋤U

###### 7.3.1 uf[^3v̕
###### \7.5 uf[^3v̕ϒl
wK03<-read.csv("./scrT/dat/wK03.csv", header = TRUE)
round(tapply(wK03$post,wK01$subject,mean),1)
round(tapply(wK03$pre ,wK01$subject,mean),1)

###### }7.7 uf[^3v̎Uz}
plot2g(y=wK03$post,x=wK03$pre,a=wK02$subject,ba=3);#}7.7
#dev.copy2eps(file="z0707.eps",family='Japan1')

#############################U(XقȂ郂f)stanR[h
ANCOVAdef<-'
//U(XقȂ郂f)
data { 
  int<lower=0>  n;                     //f[^ 
  vector[n]     y;                     //ϐ   
  vector[n]     x;                     //\ϐ   
  int<lower=0,upper=2> k[n];           //ޕϐ 
}
parameters {
  vector[2]   a;                       //ؕ
  vector[2]   b;                       //AW 
  real<lower=0> sigma;                 //덷W΍
}
transformed parameters {
  vector[n]  yhat;                     //\l yhat  
  for(i in 1:n)
    yhat[i] = a[k[i]] + x[i]*b[k[i]];  //(7.7),(7.8)
}
model {
    y ~ normal(yhat, sigma);           //(7.9)
}
';

par<-c("a","b","sigma")                       
dataSetdef03 <-list(n=nrow(wK03),y=wK03[,2],x=wK03[,1],k=wK03[,3])

###########cmdstanrɂs
modfiledef03 <- write_stan_file(ANCOVAdef)             #oꎞt@C
moddef03 <- cmdstan_model(modfiledef03)                #RpC
csrfitdef03<-moddef03$sample(data=dataSetdef03,chains = 5,iter_sampling=20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitdef03 <- rstan::read_stan_csv(csrfitdef03$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitdef03<-stan(model_code =ANCOVAdef,pars=par,data=dataSetdef03,
#  seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitdef03,  file="./scrT/obje/stan_obje0703")
#load(file="./scrT/obje/stan_obje0703"); #\stan( )ōobject[h

extdef03<-extract(fitdef03, par);               #̎o

###### \7.6 uf[^3v̌XقȂ郂fɂꐔ̎㕪z̗v
gqcal(extdef03$a[,1],2)
gqcal(extdef03$a[,2],2)
gqcal(extdef03$b[,1],2)
gqcal(extdef03$b[,2],2)
gqcal(extdef03$sigma,2)

###### }7.8 uf[^3v̉A(XقȂ)
plot2gdef(y=wK03$post,x=wK03$pre,       
          a=wK03$subject,ext=extdef03,ba=3)
#dev.copy2eps(file="z0708.eps",family='Japan1')

######  }7.9 uf[^3v̗\l̍̓_l95%\
plot2gdefdef(x=wK03[,1],extdef03);                  #}7.9
#dev.copy2eps(file="z0709.eps",family='Japan1')

########7. 3. 2 uf[^1vƁuf[^2v̍ĕ

#uf[^1v̌XقȂ郂fł̍ĕ
###########cmdstanrɂs
### RpCʂ(XقȂ郂f)'moddef03'f[^'dataSetequ01'
csrfitdef01<-moddef03$sample(data=dataSetequ01,chains=5,iter_sampling=20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitdef01 <- rstan::read_stan_csv(csrfitdef01$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitdef01<-stan(model_code =ANCOVAdef,pars=par,data=dataSetequ01,
#  seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitdef01,  file="./scrT/obje/stan_obje0704")
#load(file="./scrT/obje/stan_obje0704"); #\stan( )ōobject[h

extdef01<-extract(fitdef01, par);               #̎o

#### uf[^1v̌XقȂ郂fɂꐔ̎㕪z̗v(ȏɂȂ)
gqcal(extdef01$a[,1],2)
gqcal(extdef01$a[,2],2)
gqcal(extdef01$b[,1],2)
gqcal(extdef01$b[,2],2)
gqcal(extdef01$sigma,2)


###### }7.10 uf[^1v̉A(XقȂ)
plot2gdef(y=wK01$post,x=wK01$pre,a=wK01$subject,ext=extdef01)
#dev.copy2eps(file="z0710.eps",family='Japan1')

###### }7.11 uf[^1v̗\l̍̓_l95%\
plot2gdefdef(x=wK01[,1],extdef01); abline(h=4.8)
#dev.copy2eps(file="z0711.eps",family='Japan1')


#uf[^2v̌XقȂ郂fł̍ĕ
###########cmdstanrɂs
### RpCʂ(XقȂ郂f)'moddef03'f[^'dataSetequ02'
csrfitdef02<-moddef03$sample(data=dataSetequ02,chains=5,iter_sampling=20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitdef02 <- rstan::read_stan_csv(csrfitdef02$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitdef02<-stan(model_code =ANCOVAdef,pars=par,data=dataSetequ02,
#  seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitdef02,  file="./scrT/obje/stan_obje0705")
#load(file="./scrT/obje/stan_obje0705"); #\stan( )ōobject[h

extdef02<-extract(fitdef02, par);               #̎o


###### }7.12 uf[^2v̉A(XقȂ)
plot2gdef(y=wK02$post,x=wK02$pre,a=wK02$subject,ext=extdef02)
#dev.copy2eps(file="z0712.eps",family='Japan1')

###### }7.13 uf[^2v̗\l̍̓_l95%\
plot2gdefdef(x=wK02[,1],extdef02)
#dev.copy2eps(file="z0713.eps",family='Japan1')


########7. 3. 3 X̍̎㕪z
###### \7.7 X̍̎㕪z̗v
b_sa01<-extdef01$b[,1]-extdef01$b[,2]
gqcal(b_sa01)
b_sa02<-extdef02$b[,1]-extdef02$b[,2]
gqcal(b_sa02)
b_sa03<-extdef03$b[,1]-extdef03$b[,2]
gqcal(b_sa03)


###### 7.4  XXRA
###### 7.4.2  f[^̐
###### \7.8 wKm̊̃NX𗘗pV@̌ʂ̌؎f[^
wK04<-read.csv("./scrT/dat/propen.csv", header = TRUE)
head(wK04)
tail(wK04)

###### ϐƂ̓xiQ p.103, bl.4 ȊÓAȏɂ͂Ȃj
table(wK04$Q)
table(wK04$Z)
table(wK04$)
table(wK04$ꋳ)
table(wK04$)

###### \7.9 QƑΏƌQ̕ϒl
round(tapply(wK04$,wK04$Q,mean),1)
round(tapply(wK04$Z,wK04$Q,mean),1)
round(tapply(wK04$,wK04$Q,mean),1)
round(tapply(wK04$ꋳ,wK04$Q,mean),1)
round(tapply(wK04$,wK04$Q,mean),1)

#################################XXRAɂ镪͂stanR[h
propensity01<-'
data { 
  int<lower=0>  n;                     //f[^ 
  int<lower=0>  p;                     //\ϐ 
  vector[n]     y;                     //ϐ   
  matrix[n,p]   x;                     //\ϐ   
  int<lower=1,upper=2> k[n];           //ޕϐ 1QQΏƌQ
}
transformed data {
  int<lower=0,upper=1> kk[n];           //ޕϐ 
  for(i in 1:n){
    kk[i]=k[i]*(-1)+2;
  }
}
parameters {
  vector[2]   a;                       //ؕ
  real        b;                       //AW 
  real        alpha;                   //WXeBbNAؕ
  vector[p]   beta;                    //WXeBbNAW
  real<lower=0> sigma;                 //덷W΍
}
transformed parameters {
  vector[n]  yhat;                       //yhat  
  vector<lower=0,upper=1>[n] propensity; //XXRA
  for(i in 1:n){
    propensity[i] = inv_logit(alpha + x[i,]*beta);
    yhat[i] = a[k[i]] + propensity[i]*b;
  }
}
model {
  for(i in 1:n){
    kk[i] ~ bernoulli(propensity[i]);         //xkCzf
    y[i] ~ normal(yhat[i], sigma);           //Kzf
  }
}
generated quantities{
}
';

par<-c("a","b","sigma","alpha","beta","propensity")    #ꐔ
dataSetpropen01 <-list(n=nrow(wK04),p=4,y=wK04[,2],
                       x=wK04[,c(3:6)],k=wK04[,1]) #

###########cmdstanrɂs
modfilepropen01 <- write_stan_file(propensity01)    #oꎞt@C
modpropen01 <- cmdstan_model(modfilepropen01)       #RpC
csrfitpropen01 <- modpropen01$sample(data = dataSetpropen01,chains = 5,
   iter_sampling=20000,iter_warmup=1000,parallel_chains= 5,seed=1234)  #MCMC
fitpropen01 <- rstan::read_stan_csv(csrfitpropen01$output_files()) #stan֕ϊ

###########rstanɂs
#fitpropen01<-stan(model_code =propensity01,pars=par,data=dataSetpropen01,
#  seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitpropen01,  file="./scrT/obje/stan_obje0706")
#load(file="./scrT/obje/stan_obje0706"); #\stan( )ōobject[h

extpropen01<-extract(fitpropen01, par);               #̎o

###### \7.10 XXRAϗʂƂU͂̕ꐔ̎㕪z̗v
gqcal(extpropen01$a[,1],2)
gqcal(extpropen01$a[,2],2)
gqcal(extpropen01$b    ,2)
gqcal(extpropen01$sigma,2)
gqcal(extpropen01$alpha,2)
gqcal(extpropen01$beta[,1],2)
gqcal(extpropen01$beta[,2],2)
gqcal(extpropen01$beta[,3],2)
gqcal(extpropen01$beta[,4],2)
gqcal(extpropen01$propensity[,1],2)
gqcal(extpropen01$propensity[,2],2)
gqcal(extpropen01$propensity[,3],2)
gqcal(extpropen01$propensity[,4],2)


###### }7.14 Qʂ̌XXRÃqXgO
propen01<-apply(extpropen01$propensity,2,mean);       #XXRAEAP
K<-seq(0,1,0.1)
barplot(table(wK04$Q,cut(propen01,K,include.lowest = T,right = F)),
   xlab="propensity score", axisnames = F,cex.lab=2.0,cex.axis=1.5)
#dev.copy2eps(file="z0714.eps",family='Japan1')

###### }7.15 ROC Ȑ
(ROC1<-roc(wK04$Q ~ propen01,ci=T))
plot(ROC1,cex.lab=2.0,cex.axis=1.5)
#dev.copy2eps(file="z0715.eps",family='Japan1')

###### }7.16 XXRAϗʂƂU
plot2gequ(y=wK04$,x=propen01,a=wK04$Q,
          ext=extpropen01,ba=0,xlab="propensity score")
#dev.copy2eps(file="z0716.eps",family='Japan1')

###### }7.17 ؕЂ̍̎㕪z
a_sa04<-extpropen01$a[,1]-extpropen01$a[,2]
gqcal(a_sa04,1);
hist(a_sa04,br=100,cex.lab=2.0,cex.axis=1.5,xlab="a1 [ a2",ylab="",main="")
#dev.copy2eps(file="z0717.eps",family='Japan1')

#######uؕЂ̍ROPE(1.0)łvphc  p,108,l.3
mean(abs(a_sa04)<1)

#ȉK͂Ȃ
set.seed(1234)
match<-Match(Tr= wK04$Q*-1+2, X=propen01, M=1, caliper=0.2, replace=F)
match
