############# 9́@Kw`f
# Working directory 'toyoda' ł邱Ƃ̊mF
(n_wd<-getwd())                #working directory(wd)̊mF
(setwd('./scrT'))              #wd̈ړ
source('../myfunc/myfunc.R')   #֐̓ǂݍ
(setwd(n_wd))                  #wd߂
library(rstan)                 #pbP[WrstaňĂяo
library(cmdstanr)              #pbP[WcmdstanřĂяo
library(posterior)             #pbP[WposteriořĂяo
prob<-c(0.025, 0.05, 0.5, 0.95, 0.975) #m_̒`

###### 9. 1 ؕЂƉAWɕz肵f
###### 9. 1. 1 moꂽɊւ

###### \9.1 moꂽɊւ
(mo11<-read.csv("./scrT/dat/mo11.csv", header = TRUE))

###### }9.1 moꂽ̎(2 )
X<-mo11[((mo11$w==17)|(mo11$w==1)), ]
plot(X$,X$ڑ,pch=X$w,xlab="",ylab="ڑ")
  legend(60,160,c("w1","w17"),pch=c(1,17),cex=1.5)
#dev.copy2eps(file="z0806.eps",family='Japan1')

###### }9.2 moꂽ̎(25 )
plot(mo11$,mo11$ڑ,pch=mo11$w,   #}9.2
     xlab="",ylab="ڑ")

###############ؕЂƉAWɕz肵fstanR[h
HLM01<-'
data { 
  int<lower=0>  n;                     //Sf[^ 
  int<lower=0>  J;                     //Q
  vector[n]     y;                     //ϐ   
  vector[n]     x;                     //\ϐ   
  int<lower=0>  k[n];                  //ޕϐ 
}
parameters {
  vector[J]   a;                       //ؕ
  vector[J]   b;                       //AW 
  real<lower=0> sigma;                 //덷W΍
  real        a0;                      //ؕЕ 
  real        b0;                      //AW 
  real<lower=0> s_a;                   //ؕSD
  real<lower=0> s_b;                   //AWSD
}
transformed parameters {
  vector[n]  yhat;                     //\l
  for(i in 1:n)
    yhat[i] = a[k[i]] + x[i]*b[k[i]];  //(9.1)
}
model {
    y ~ normal(yhat, sigma);           //(9.2)
    a ~ normal(a0, s_a);               //(9.3)
    b ~ normal(b0, s_b);               //(9.4)
}
';

par<-c("sigma","a0","b0","s_a","s_b","a","b")                    #ꐔ
dataSet81 <-list(n=length(mo11$ڑ), J=max(mo11$w), 
  y=mo11$ڑ, x=mo11$, k=mo11$w)             #̓f[^

###########cmdstanrɂs
modfile81 <- write_stan_file(HLM01)           #oꎞt@C
mod81 <- cmdstan_model(modfile81)                   #RpC
csrfit81 <- mod81$sample(data = dataSet81,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit81 <- rstan::read_stan_csv(csrfit81$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit81<-stan(model_code =HLM01,data=dataSet81,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit81,  file="./scrT/obje/stan_obje0901")
#load(file="./scrT/obje/stan_obje0901"); #\stan( )ōobject[h

ext81<-extract(fit81, par);               #̎o

###### \9.2 ؕЂƉAWzf̕ꐔ̎㕪z̗v
gqcal(ext81$sigma)
gqcal(ext81$a0   )
gqcal(ext81$b0   )
gqcal(ext81$s_a  )
gqcal(ext81$s_b  )

##### 25{̐ؕЁEAWEAPl(}̂߂łAȏɂ͂Ȃ)
av<-apply(ext81$a,2,mean)
bv<-apply(ext81$b,2,mean)
round(rbind(av,bv),2)

###### }9.3 25 {̒PA
plot(mo11$,mo11$ڑ,pch=mo11$w,
    xlab="",ylab="ڑ",type="n")
    for (i in 1:25) {abline(av[i],bv[i],lwd=1.8)}

##### }9.4 AW̕W΍̎㕪z
hist(ext81$s_b,breaks=100,main="",ylab="",xlab="AW̕W΍")

##### }9.5 ؕЂƉAW̎Uz}
plot(av,bv,pch=16,xlab="ؕ",ylab="AW")

cor(av,bv);                  ؕЂƌX̑֌W p.131,l.3


###### 9. 2 ؕЂɕz肵f
###### 9. 2. 1 wZʂ̒w̐тƍZ̕΍l

##### \9.3 wZʂ̒w̐тƍZ̕΍l
(w͕ω<-read.csv("./scrT/dat/w͕ω.csv", header = TRUE))

##### }9.6 Z2 9 ̒EZ̕΍l
X<-w͕ω[((w͕ω$wZ==2)|(w͕ω$wZ==9)), ]
plot(X$w,X$Z,pch=X$wZ,xlab="wRN΍l",
   ylab="ZPN΍l", xlim=c(25,75),ylim=c(25,75))
legend(30,70,c("ZQ","ZX"),pch=c(2,9))

##### }9.7   10Z̒wƍZ̕΍l
plot(w͕ω$w,w͕ω$Z,pch=w͕ω$wZ,xlab="wRN΍l",
      ylab="ZPN΍l", xlim=c(25,75),ylim=c(25,75))

###### ܂͐ؕЂƉAWɕz肵f
par<-c("sigma","a0","b0","s_a","s_b","a","b")                      #ꐔ
dataSet821 <-list(n=length(w͕ω$Z),J=max(w͕ω$wZ),
                  y=w͕ω$Z,x=w͕ω$w, k=w͕ω$wZ)#

###########cmdstanrɂs
#RpCʂ 'mod81' 𗘗p
csrfit821 <- mod81$sample(data = dataSet821,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit821 <- rstan::read_stan_csv(csrfit821$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit821<-stan(model_code =HLM01,data=dataSet821,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit821,  file="./scrT/obje/stan_obje0902")
#load(file="./scrT/obje/stan_obje0902"); #\stan( )ōobject[h

ext821<-extract(fit821, par);               #̎o

###### \9.4 ؕЂƉAWɕẑ郂f̕ꐔ
###### ̎㕪z̗v(΍lf[^)
gqcal(ext821$sigma)
gqcal(ext821$a0   )
gqcal(ext821$b0   )
gqcal(ext821$s_a  )
gqcal(ext821$s_b  )

##### ؕЁEAWEAPl(}̂߂łAȏɂ͂Ȃ)
av<-apply(ext821$a,2,mean)
bv<-apply(ext821$b,2,mean)
round(rbind(av,bv),2)

##### }9.8 Zʂ10 {̒PA
plot(w͕ω$w,w͕ω$Z,pch=w͕ω$wZ,xlab="wRN΍l",
     ylab="ZPN΍l", xlim=c(25,75),ylim=c(25,75),type="n")
     for (i in 1:10) {abline(av[i],bv[i],lwd=1.8)}

##### }9.9 AW̕W΍̎㕪z
hist(ext821$s_b,breaks=100,main="",ylab="",xlab="AW̕W΍")

###################ؕЂɕz肵fstanR[h
HLM02<-'
data { 
  int<lower=0>  n;                     //Sf[^ 
  int<lower=0>  J;                     //Q
  vector[n]     y;                     //ϐ   
  vector[n]     x;                     //\ϐ   
  int<lower=0>  k[n];                  //ޕϐ 
}
parameters {
  vector[J]   a;                       //ؕ
  real        b;                       //AW 
  real<lower=0> sigma;                 //덷W΍
  real        a0;                      //ؕЕ 
  real<lower=0> s_a;                   //ؕSD
}
transformed parameters {
  vector[n]  yhat;                     //\l
  for(i in 1:n)
    yhat[i] = a[k[i]] + x[i]*b;        //(9.5),(9.8)
}
model {
    y ~ normal(yhat, sigma);           //(9.6)
    a ~ normal(a0, s_a);               //(9.7)
}
';

par<-c("sigma","a0","b","s_a","a")                               #ꐔ
dataSet822 <-list(n=length(w͕ω$Z),J=max(w͕ω$wZ),
   y=w͕ω$Z,x=w͕ω$w, k=w͕ω$wZ)             #

###########cmdstanrɂs
modfile822 <- write_stan_file(HLM02)             #oꎞt@C
mod822 <- cmdstan_model(modfile822)                   #RpC
csrfit822 <- mod822$sample(data = dataSet822,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit822 <- rstan::read_stan_csv(csrfit822$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit822<-stan(model_code =HLM02,data=dataSet822,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit822,  file="./scrT/obje/stan_obje0903")
#load(file="./scrT/obje/stan_obje0903"); #\stan( )ōobject[h

ext822<-extract(fit822, par);             #̎o

###### \9.5 ؕЂɕz郂f̕ꐔ̎㕪z̗v
gqcal(ext822$sigma )
gqcal(ext822$a0    )
gqcal(ext822$b     )
gqcal(ext822$s_a   )
print('-------------------------------------')
gqcal(ext822$a[,1] )
gqcal(ext822$a[,2] )
gqcal(ext822$a[,3] )
gqcal(ext822$a[,4] )
gqcal(ext822$a[,5] )
gqcal(ext822$a[,6] )
gqcal(ext822$a[,7] )
gqcal(ext822$a[,8] )
gqcal(ext822$a[,9] )
gqcal(ext822$a[,10])

###### \9.6 ؕЂɊւčwZi sj 傫m
phc02(0,ext822$a,digits=2)

###### }9.10 wZ8 7 ̐ؕЂ̍c ȏłm
phc01(seq(2,8,0.2),ext822$a[,8],ext822$a[,7],xlab="wZ87̐ؕЂ̍")

###### 9. 3 ؕЂƌXɑւ̂郂f
###### 9. 3. 1 ʊJn4 TԂ̑̏dω

###### \9.7 ʊJn4 TԂ̑̏dω
(ʌo<-read.csv("./scrT/dat/ʌo.csv", header = TRUE))

###### }9.11 4 TԂ̑̏dω(4 l)
Y<-ʌo[ʌo$==14,]
plot(Y$T,Y$̏d,pch=Y$,xlab="ʊJn̏T",
  ylab="̏d",ylim=c(46,54),type="b")
  for (i in 15:17){
    Y<-ʌo[ʌo$==i,]
    par(new=T)
    plot(Y$T,Y$̏d,pch=Y$,xlab="",ylab="",
      ylim=c(46,54),type="b")
  }
  legend(3.2,53.5,c("14","15","16","17"),pch=c(14:17))
#dev.copy2eps(file="z0811.eps",family='Japan1')

###### }9.12 4 TԂ̑̏dω(S)
Y<-ʌo[ʌo$==1,]
plot(Y$T,Y$̏d,xlab="ʊJn̏T",
  ylab="̏d",ylim=c(46,54),type="l")
  for (i in 2:50){
    Y<-ʌo[ʌo$==i,]
    par(new=T)
    plot(Y$T,Y$̏d,xlab="",ylab="",ylim=c(46,54),type="l")
}

par<-c("sigma","a0","b0","s_a","s_b","a","b")                     #ꐔ
dataSet91 <-list(n=length(ʌo$̏d), J=max(ʌo$), 
    y=ʌo$̏d, x=ʌo$T, k=ʌo$)            #

###########cmdstanrɂs
#RpCʂ 'mod81' 𗘗p
csrfit91 <- mod81$sample(data = dataSet91,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit91 <- rstan::read_stan_csv(csrfit91$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit91<-stan(model_code =HLM01,data=dataSet91,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit91,  file="./scrT/obje/stan_obje0904")
#load(file="./scrT/obje/stan_obje0904"); #\stan( )ōobject[h

ext91<-extract(fit91, par);               #̎o

###### \9.8 ؕЂƉAWɕz肵f̎㕪z̗v
gqcal(ext91$sigma)
gqcal(ext91$a0   )
gqcal(ext91$b0   )
gqcal(ext91$s_a  )
gqcal(ext91$s_b  )

##### ؕЁEAWEAPl
av<-apply(ext91$a,2,mean)
bv<-apply(ext91$b,2,mean)
round(rbind(av,bv),2)

###### }9.13 ؕЂƉAW̎Uz}
plot(av,bv,pch=16,xlab="ؕ",ylab="AW");  abline(h=0.0)

cor(av,bv);                  #ؕЂƌX̑֌W p.137,l.6


######################ؕЂƌXɑւ̂郂fstanR[h
HLM03<-'
data { 
  int<lower=0>  n;                     //Sf[^ 
  int<lower=0>  J;                     //Q
  vector[n]     y;                     //ϐ   
  vector[n]     x;                     //\ϐ   
  int<lower=0>  k[n];                  //ޕϐ 
}
parameters {
  matrix[J,2]   ab;                    //ؕЁEAW 
  real<lower=0> sigma;                 //덷W΍
  real        a0;                      //ؕЕ 
  real        b0;                      //AW 
  real<lower=0> s_a;                   //ؕSD
  real<lower=0> s_b;                   //AWSD
  real<lower=-1,upper=1> rho;          //ؕЂƉAW̑
}
transformed parameters {
  vector[n]  yhat;                     //\l
  vector[2]  mu;                       //ؕЁEAW
  cov_matrix[2]  Sigma;                //ؕЁEAW̕UUs
  mu[1] = a0;                          //ؕЂ̕ςʂ̑1vfɑ
  mu[2] = b0;                          //AW̕ςʂ̑2vfɑ
  Sigma[1,1]  = pow(s_a,2);            //ؕЂ̕U
  Sigma[2,2]  = pow(s_b,2);            //AW̕U
  Sigma[1,2]  = s_a*s_b*rho;           //ؕЂƉAW̋U
  Sigma[2,1]  = Sigma[1,2];            //
  for(i in 1:n)
    yhat[i] = ab[k[i],1] + x[i]*ab[k[i],2]; //(9.10) \l̍\
}
model {                                //yyhat̎ŐKzɏ]
  y ~ normal(yhat, sigma);             //(9.11)@xNg\LforȂ
  for(j in 1:J)                        //ؕЂƉAW͂QϗʐKzɏ]
     ab[j,]~multi_normal(mu,Sigma);    //(9.12)
}
';

par<-c("sigma","a0","b0","s_a","s_b","rho","ab")                 #ꐔ
dataSet92 <-list(n=length(ʌo$̏d), J=max(ʌo$), 
    y=ʌo$̏d, x=ʌo$T, k=ʌo$ )          #

###########cmdstanrɂs
modfile92 <- write_stan_file(HLM03)             #oꎞt@C
mod92 <- cmdstan_model(modfile92)                   #RpC
csrfit92 <- mod92$sample(data = dataSet92,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit92 <- rstan::read_stan_csv(csrfit92$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit92<-stan(model_code =HLM03,data=dataSet92,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit92,  file="./scrT/obje/stan_obje0905")
#load(file="./scrT/obje/stan_obje0905"); #\stan( )ōobject[h

ext92<-extract(fit92, par);               #̎o

###### \9.9 ؕЂƉAWɑւ̂郂f̕ꐔ̎㕪z̗v
gqcal(ext92$sigma)
gqcal(ext92$a0   )
gqcal(ext92$b0   )
gqcal(ext92$s_a  )
gqcal(ext92$s_b  )
gqcal(ext92$rho  )

##### ؕЁEAWEAPl
av<-apply(ext92$ab[,,1],2,mean)
bv<-apply(ext92$ab[,,2],2,mean)
round(rbind(av,bv),2)

#### }9.14 50 {̒PA
plot(ʌo$T,ʌo$̏d,pch=ʌo$,
    xlab="T",ylab="̏d",type="n")
    for (i in 1:50) {abline(av[i],bv[i],lwd=1.8)}

##### }9.15 ؕЂƉAW̑ւ̎㕪z
hist(ext92$rho,breaks=100,main="",ylab="",xlab="ؕЂƉAW̑")

cor(av,bv);                  #ؕЂƌX̑֌W(ȏɂ͂Ȃ)


####### 9. 4 x2 ̕ϐ郂f
####### 9. 4. 1 ΑNƔN̕

##############\9.10 ƕʂ̋ΑNƔN
(ΑN<-read.csv("./scrT/dat/ΑN.csv", header = TRUE))

##############\9.11 Ƃ̎{̋K
({  <-read.csv("./scrT/dat/{.csv",   header = TRUE))

############### 3̊Ƃ̋ΑNƔN̎Uz}iȏɂ͂Ȃj
X<-ΑN[((ΑN$==3)|(ΑN$==15)|
             (ΑN$==21)), ]
plot(X$ΑN,X$N,pch=X$,xlab="Ђ̔N",ylab="N")
    legend(2.5,850,c("3","15","21"),pch=c(3,15,21))

##############}9.16 ΑNƔN̕
plot(ΑN$ΑN,ΑN$N,pch=ΑN$,
    xlab="Ђ̔N",ylab="N");               #}9.16


############################xQ̕ϐ郂fstanR[h
HLM04<-'
data { 
  int<lower=0>  n;                     //Sf[^ 
  int<lower=0>  J;                     //Q
  vector[n]     y;                     //ϐ   
  vector[n]     x;                     //\ϐ   
  vector[J]     z;                     //xQ̕ϐ   
  int<lower=0>  k[n];                  //ޕϐ 
}
parameters {
  vector[J]   a;                       //ؕ
  vector[J]   b;                       //AW 
  real<lower=0> sigmae;                //덷W΍
  real        a0;                      //ؕЂ̐ؕ 
  real        b0;                      //AW̐ؕ 
  real        ca;                      //ؕЂ̌W 
  real        cb;                      //AW̌W 
  real<lower=0> sigmaa;                //ؕSD
  real<lower=0> sigmab;                //AWSD
}
transformed parameters {
  vector[n]  yhat;                     //\l
  for(i in 1:n)
    yhat[i] = a[k[i]] + x[i]*b[k[i]];  //(9.14)
}
model {
    y ~ normal(yhat, sigmae);          //(9.15)
    a ~ normal(a0+ z*ca, sigmaa);      //(9.16)
    b ~ normal(b0+ z*cb, sigmab);      //(9.17)
}
';

par<-c("sigmae","a0","b0","ca","cb","sigmaa","sigmab","a","b")#ꐔ
dataSet93 <-list(n=length(ΑN$N),J=max(ΑN$), 
 y=ΑN$N, x=ΑN$ΑN, z={$敪, k=ΑN$ )#

###########cmdstanrɂs
modfile93 <- write_stan_file(HLM04)             #oꎞt@C
mod93 <- cmdstan_model(modfile93)                   #RpC
csrfit93 <- mod93$sample(data = dataSet93,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit93 <- rstan::read_stan_csv(csrfit93$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit93<-stan(model_code =HLM04,data=dataSet93,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit93,  file="./scrT/obje/stan_obje0906")
#load(file="./scrT/obje/stan_obje0906"); #\stan( )ōobject[h

ext93<-extract(fit93, par);               #̎o

###### \9.12 x2 ̕ϐ郂f̕ꐔ̎㕪z
gqcal(ext93$sigmae)
gqcal(ext93$a0)
gqcal(ext93$b0)
gqcal(ext93$ca)
gqcal(ext93$cb)
gqcal(ext93$sigmaa)
gqcal(ext93$sigmab)

#### ؕЁEAWEAPl
av<-apply(ext93$a,2,mean)
bv<-apply(ext93$b,2,mean)
round(rbind(av,bv),2)

######}9.17 x1 25 {̉A
plot(ΑN$ΑN,ΑN$N,xlab="ΑN",ylab="N",type="n")
  for (i in 1:25) {abline(av[i],bv[i],lwd=1.8,lty=({[i,2]+3))}
  legend(2.5,900,paste("敪",-2:2,sep=""),lty=1:5)

######}9.18 x2 ̕ϐɂؕЂɑ΂A
plot({[,2],av,ylab="xP̐ؕ",xlab="{敪",pch=16)
  abline(a=mean(ext93$a0),b=mean(ext93$ca))

######}9.19 x2 ̕ϐɂAWɑ΂A
plot({[,2],bv,ylab="xP̉AW",xlab="{敪",pch=16)
  abline(a=mean(ext93$b0),b=mean(ext93$cb))

cor(av,bv);                  #ؕЂƌX̑֌W(ȏɂ͂Ȃ)


###### 9. 5 XʂŃx2 ̎Iϐ郂f

######\9.13 ʉpꋳ{Ă邩ۂɊւ郌x2 ̕ϐ
(w͕ω<-read.csv("./scrT/dat/w͕ω.csv", header = TRUE))
ʉp<-c(0,0,1,1,0,0,1,1,1,1)


################XʂŃxQ̎Iϐ郂fstanR[h
HLM05<-'
data { 
  int<lower=0>  n;                     //Sf[^ 
  int<lower=0>  J;                     //Q
  vector[n]     y;                     //ϐ   
  vector[n]     x;                     //\ϐ   
  vector[J]     z;                     //xQ̕ϐ   
  int<lower=0>  k[n];                 //ޕϐ 
}
parameters {
  vector[J]   a;                       //ؕ
  real        b;                       //AW 
  real<lower=0> sigmae;                //덷W΍
  real        a0;                      //ؕЕ 
  real        ca;                      //ؕЂ̌W 
  real<lower=0> sigmaa;                //ؕSD
}
transformed parameters {
  vector[n]  yhat;                     //\l
  for(i in 1:n)
    yhat[i] = a[k[i]] + x[i]*b;        //(9.18)
}
model {
    y ~ normal(yhat, sigmae);          //(9.19)
    a ~ normal(a0+ z*ca, sigmaa);      //(9.20),(9.21)
}
';

par<-c("sigmae","a0","ca","sigmaa","b","a")                     #ꐔ
dataSet94 <-list(n=length(w͕ω$Z),J=max(w͕ω$wZ),
   y=w͕ω$Z,x=w͕ω$w, z=ʉp, k=w͕ω$wZ)#

###########cmdstanrɂs
modfile94 <- write_stan_file(HLM05)             #oꎞt@C
mod94 <- cmdstan_model(modfile94)                   #RpC
csrfit94 <- mod94$sample(data = dataSet94,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit94 <- rstan::read_stan_csv(csrfit94$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit94<-stan(model_code =HLM05,data=dataSet94,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit94,  file="./scrT/obje/stan_obje0907")
#load(file="./scrT/obje/stan_obje0907"); #\stan( )ōobject[h

ext94<-extract(fit94, par);               #̎o

### \9.14 XʂŃx2 ̎Iϐ郂f̕ꐔ̎㕪z̗v
gqcal(ext94$sigmae)
gqcal(ext94$a0)
gqcal(ext94$ca)
gqcal(ext94$sigmaa)
gqcal(ext94$b)

#### ؕЁEAWEAPl
av<-apply(ext94$a,2,mean)
bv<-mean(ext94$b)
round(rbind(av,bv),2)

###### }9.20 ʋĂ邩ۂɂȂ
plot(w͕ω$w,w͕ω$Z,xlab="wRN΍l",
  ylab="ZPN΍l", xlim=c(25,75),ylim=c(25,75),type="n")
  for (i in 1:10) {
    abline(av[i],bv,lwd=1.9,lty=((ʉp[i])*(-1)+2) )
  }
  legend(30,70,c("ʋ炠","ʋȂ"),lty=c(1,2))

mean(ext94$ca>0);   #ʋ̌ʂm p.143,l.3

##### }9.21 ʋĂ鍂Z̐ؕЂ̕ς̍c ȏłm
phc01(seq(0,10,0.5),ext94$ca,0,xlab="ؕЂ̍")

################################# Kۑ

#
#     ͊
#
