##############10́@Ԑڎ@
# Working directory 'toyoda' ł邱Ƃ̊mF
(n_wd<-getwd())                #working directory(wd)̊mF
(setwd('./scrT'))              #wd̈ړ
source('../myfunc/myfunc.R')   #֐̓ǂݍ
(setwd(n_wd))                  #wd߂
library(rstan)                 #pbP[WrstaňĂяo
library(cmdstanr)              #pbP[WcmdstanřĂяo
library(posterior)             #pbP[WposteriořĂяo
prob<-c(0.025, 0.05, 0.5, 0.95, 0.975) #m_̒`

#######################################{͂ŗp֐
#MAPl^֐
MAP<-function(ext){density(ext)$x[which.max(density(ext)$y)]}

###### 10. 1 z
###### }10.1 lƎq̐g̃qXgO
(g<-read.csv("./scrT/dat/g.csv", header = TRUE))
hist(g$x,breaks = 12,col=8,main="",xlab="g(cm)",ylab="l");#}10.1

#######################################zfstanR[h
mix01<-'
data {                                 //͕
  int<lower=0> n;                      //f[^
  real      x[n];                      //f[^
  real<lower=0,upper=1> p;             //䗦
}
parameters {                           //ꐔ`
  ordered[2]   mu;                     //
  real<lower=0> sigma[2];              //W΍
}
model {                                //fLq
   for(i in 1:n)
      target += log_sum_exp(           //(10.9)
         log(p)  +normal_lpdf(x[i]|mu[1],sigma[1]),
         log(1-p)+normal_lpdf(x[i]|mu[2],sigma[2])
   );
}
';

par<-c("mu","sigma")                              #ꐔ
dataSetmix <-list(n=length(g$x),x=g$x,p=0.4) #

###########cmdstanrɂs
modfilemix <- write_stan_file(mix01)              #oꎞt@C  
modmix <- cmdstan_model(modfilemix)                   #RpC
csrfitmix <- modmix$sample(data = dataSetmix,chains = 5,iter_sampling = 20000,
    init = function(){list(mu=c(138,172),sigma=c(5.8,6.8))},
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitmix <- rstan::read_stan_csv(csrfitmix$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitmix<-stan(model_code =mix01,data=dataSetmix,
#  pars=par,seed=1234,chains=1,warmup=400,iter=2400)
#save(fitmix,file="./scrT/obje/stan_obje1001")
#load(file="./scrT/obje/stan_obje1001"); #\stan( )ōobject[h

extmix<-extract(fitmix, par);               #̎o

########### \10.1 Kf̎㕪z̗v
print(fitmix,digits_summary=3, probs =prob)


###### 10. 2 _񓚖@
yes<-1168; no<-3072;       
x<-c(rep(1,yes),rep(0,no));                #댯hbǑo䗦
2.0*(yes/(yes+no))-0.5 ;                   #ȕ։ (10.11)

###########################################_񓚖@stanR[h
random01<-'
//_񓚖@
data {                                 //͕
  int<lower=0> n;                      //f[^
  int<lower=0> x[n];                   //f[^
  real<lower=0,upper=1> q;             //}XN䗦
}
parameters {                           //ꐔ`
  real<lower=0,upper=1> p;             //m肽䗦
}
model {                                //fLq
   for(i in 1:n)
      target += log_sum_exp(           //(10.12)̑ΐ̎w̘ȃΐ
         log(0.5)+bernoulli_lpmf(x[i]|p),
         log(0.5)+bernoulli_lpmf(x[i]|q)
   );
}
';

par<-c("p")                                 #ꐔ
dataSetrand <-list(n=length(x),x=x,q=0.5)     #

###########cmdstanrɂs
modfilerand <- write_stan_file(random01)              #oꎞt@C  
modrand <- cmdstan_model(modfilerand)                   #RpC
csrfitrand <- modrand$sample(data=dataSetrand,chains=5,iter_sampling=20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitrand <- rstan::read_stan_csv(csrfitrand$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitrand<-stan(model_code =random01,data=dataSetrand,
#  pars=par,seed=1234,chains=5,warmup=1000,iter=21000)
#save(fitrand,file="./scrT/obje/stan_obje1002")
#load(file="./scrT/obje/stan_obje1002"); #\stan( )ōobject[h

extrand<-extract(fitrand, par);               #̎o

###### \10.2 댯hbǑo䗦̎㕪z̗v
print(fitrand,digits_summary=3, probs =prob)

###### }10.2 댯hbǑo䗦̎㕪z
hist(extrand$p,breaks=50,main="",xlab="䗦",ylab="",xlim=c(0,0.1),
  cex.lab=2.0,cex.axis=1.5)
#dev.copy2eps(file="z0902.eps",family='Japan1')

MAP(extrand$p);                   #MAPl@p.150,l.1

###### }10.3 p(p > c) Ƃm
phc01(seq(0,0.10,0.005),extrand$p,0,xlab="䗦 > c")
#dev.copy2eps(file="z0903.eps",family='Japan1')


######## 10. 3 Aggregated Response @
######## 10. 3. 1 ِƂ̐šׂol
x<-c(
-3,-2, 1, 3,-9, 4,-1,-3,-5, 2, 0,-7,-1,-4,-3,10, 2, 6, 2,-2,-1,-6,-6,-1, 8,-6,
-6, 1, 6, 1, 1, 5, 6, 1, 2, 9, 3, 3,-2, 5, 6, 5, 0, 7,-3,-1,-1, 6, 6, 4, 4,-8,
 5, 2, 7, 7, 5,-1, 6,10, 9, 2,-8,-6,-8,-7,-2, 7, 4, 6,-5, 0,-1,14, 0, 5, 9,-2,
 7, 4,-2, 2,-8,-3,11,-5,-1,-5, 3, 6,-5,-4, 4, 4, 2,10,-3, 1, 3, 5,-6,-3,-1, 2,
-9, 2,-4, 3,-1, 1,-6, 7, 4,-5, 0, 7, 4,-7,-4,-3, 2, 2,-3, 6,-4,-6,-3, 0, 5, 3,
 6,-2, 0,10, 9, 1, 8,10, 3, 4, 5, 4, 4, 9,-5, 8,-1, 1,-7, 2, 9,-2, 5,-7,-1, 4,
 1, 3, 1, 2, 0,-4, 1,-5, 3,-6,-4,-4, 2,-1,-3,-2,-8,-3,-4, 1, 0, 1, 0, 7,-4, 7,
10, 4, 9,11, 7,10,-1, 5, 5, 0, 9,-3,-7,-6, 9, 3, 0, 7, 2, 7, 0, 3,-1,-3,-8, 0,
 0,10, 7, 1,-2,-3,-9,-7,-4, 6,-2,11,13, 8, 8,-4, 0,-1,-8, 7,10, 8, 3,10, 4,-6,
 6, 7,-5, 4,-8, 7,-7,-3, 2,-8, 3, 3,-2, 2,-3,-4,-5,-2, 7,-3, 2,-1,-7,-1,-6,-6,
10,11,-5, 6, 7, 5,-6, 8,-4,-1, 4,-2,-1,-6, 6,-5,11, 5, 1, 3, 0,-2,-7,-1,-6, 9,
-6,-7,-6, 4, 3,10, 4, 3,-1, 5, 7, 6,-4, 3, 0,12,11, 7, 8, 4,-2, 1,-6, 6,-1,-1,
 5, 4, 6,11,-7, 4,-1, 1,-2, 2,-6,-3,-7, 2,-5, 4, 2,-3)

###### }10.4 񓚐̃qXgO
hist(x,main="",xlab="񓚂",ylab="",
     xlim=c(-9.5,14.5),cex.lab=2.0,cex.axis=1.5,breaks=24)
#dev.copy2eps(file="z0904.eps",family='Japan1')

mean(x);                     #ρ@@ȕ։ (10.16)
max(x);min(x);               #őEŏ

####################Aggregated Response@stanR[h
AR01<-'data {
//Aggregated Response@
  int<lower=0> n;                      //f[^
  int<lower=0> m;                      //}XN
  int          x[n];                   //f[^
  int          mask[m];                //}XNvf
  real         pro;                    //lz̊m
}
parameters {                           //ꐔ`
  real<lower=0> lambda;                //|A\zꐔ
}
model {                                //fLq
   real         j;                     //̃f[^݂͑}XN
   int         jj;                     //
   real         pr;                    //\̂}XN̐̋t
   vector [m]  lp;
   for(i in 1:n){
      j = 0.0;
      for(k in 1:m) if (0 <= x[i]-mask[k]){ j =j +1.0;}
      pr = 1.0/j;
      jj=0;
      for(k in 1:m){                  //k̓}XN
         if (0 <= x[i]-mask[k]) {     //\̂}XNvZ
            jj=jj+1;
            lp[jj] = log(pr)+poisson_lpmf(x[i]-mask[k]|lambda);//(10.24)
         }
      }
      target += log_sum_exp( lp[1:jj] );
   }
}
';

par<-c("lambda")                                         #ꐔ
mask<-c(-9:0,0:9); m<-length(mask)                       #}XN
dataSetAR <-list(n=length(x),m=m,x=x,mask=mask,pro=1/m)  #

###########cmdstanrɂs
modfileAR <- write_stan_file(AR01)              #oꎞt@C  
modAR <- cmdstan_model(modfileAR)               #RpC
csrfitAR <- modAR$sample(data = dataSetAR,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitAR <- rstan::read_stan_csv(csrfitAR$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitAR<-stan(model_code =AR01,data=dataSetAR,
#  pars=par,seed=1234,chains=5,warmup=1000,iter=21000,init=mean(x))
#save(fitAR,file="./scrT/obje/stan_obje1003")
#load(file="./scrT/obje/stan_obje1003"); #\stan( )ōobject[h

extAR<-extract(fitAR, par);               #̎o

###### \10.3 ɂ̎㕪z̗v
print(fitAR,digits_summary=3, probs =prob)

###### }10.5 |A\z̕ꐔ̎㕪z
hist(extAR$lambda,breaks=100,main="",xlab="",ylab="",cex.lab=2,cex.axis=1.5)
#dev.copy2eps(file="z0905.eps",family='Japan1')

###### }10.6 p( > c) Ƃm
phc01(seq(0.5,2.5,0.1),extAR$lambda,0,xlab="σ > x")
#dev.copy2eps(file="z0906.eps",family='Japan1')

###### }10.7 ol̎\z
T<-length(extAR$lambda);pre<-numeric(T);         #i[̔
for(i in 1:T){ pre[i]<-rpois(1,extAR$lambda[i])} #\z
barplot(table(pre),axes=F, xlab="ol",cex.lab=2.0,cex.axis=2.0)
#dev.copy2eps(file="z0907.eps",family='Japan1')

###### \10.4 ol̊mƗݐϊm
round(table(pre)/T,3)         #m
round(cumsum(table(pre)/T),3) #ݐϊm
summary(pre)                  #ρElEől
round(sd(pre),3)              #W΍

######################10. 4 ACeJEg@
##### \10.5 ZXgƒXgɑ΂Yɂxz
a<-c(107,133,160,80,75,110, 96)
b<-c( 98,142,166,75,82,104,135, 0)
K<-6

##########################################ACeJEg@stanR[h
itemcount02<-'
data {                                 //͕
  int<lower=0> K;                      //ZXg̃JeS
  int<lower=0> a[K+1];                 //ZXg̔
  int<lower=0> b[K+2];                 //Xg̔
}
transformed data {                     //f[^ϊ
}
parameters {                           //ꐔ`
  simplex[K+1]       theta;            //ZXg̊m
  simplex[K+1]          pi;            //pɂPXg̏tm
  real<lower=0,upper=1.0>  p;          //L[ڂɂĂ͂܂m
}
transformed parameters {               //ꐔϊ
  vector[K+1]         pi1;             //ZXgkŃ}XN1ƂȂ铯m
  simplex[K+2]       theas;            //Xg̕䗦
  real  temp;                         
  pi1=pi*p;
  theas[1]=theta[1]-pi1[1];            //(10.38)
  for (j in 2:K+1){
    theas[j]=theta[j]-pi1[j]+pi1[j-1]; //(10.39)
  }
  temp=0;
  for(j in 1:K+1){ temp=temp+theas[j];}
  theas[K+2]=1-temp;
}
model {                                //fLq
  a ~ multinomial(theta);              //ZXg̑z
  b ~ multinomial(theas);              //Xg̑z
}
';

par<-c("p","theta","theas")     #ꐔ
dataSet@ <-list(K=K,a=a,b=b)   #

###########cmdstanrɂs
modfile@ <- write_stan_file(itemcount02)         #oꎞt@C  
mod@ <- cmdstan_model(modfile@)               #RpC
csrfit@ <-mod@$sample(data=dataSet@,chains=5,iter_sampling=20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fit@ <- rstan::read_stan_csv(csrfit@$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fit@<-stan(model_code =itemcount02,data=dataSet@,
#  pars=par,seed=1234,chains=5,warmup=1000,iter=21000)
#save(fit@,file="./scrT/obje/stan_obje1004")
#load(file="./scrT/obje/stan_obje1004"); #\stan( )ōobject[h

ext@<-extract(fit@, par);               #̎o

###### \10.6 p ̎㕪z̗v
print(fit@,digits_summary=3, probs =prob)
