###########1́@PA
# Working directory 'toyoda' ł邱Ƃ̊mF
(n_wd<-getwd())                #working directory(wd)̊mF
(setwd('./scrT'))              #wd̈ړ
source('../myfunc/myfunc.R')   #֐̓ǂݍ
(setwd(n_wd))                  #wd߂
library(rstan)                 #pbP[WrstaňĂяo
library(cmdstanr)              #pbP[WcmdstanřĂяo
library(posterior)             #pbP[WposteriořĂяo
prob<-c(0.025, 0.05, 0.5, 0.95, 0.975) #m_̒`

########## 1͂ŗp֐  PȀlŏ2@ŌvZ
initi01<-function(y,x){        # y:ϐ, x:\ϐ
 lmm<-lm(y ~x)                 # ŏ2@̉i[
 a<-as.numeric(coef(lmm)[1])   # 1vf̐ؕЂ̎o
 b<-as.numeric(coef(lmm)[2])   # 2vf̉AW̎o
 sigma<-as.numeric(summary(lmm)$sigma)  #e (1.5) ̎o
 list(a=a,b=b, sigma=sigma)    # Xgł܂Ƃ߂Ė߂lɂ
}

########## 1.1 Galton (1886) ̐eq̐gf[^

########  \1.2 ugf[^v̈ꕔ(cm)
eqg <- read.csv("./scrT/dat/eqg.csv", header=T)
head(eqg,n=14);tail(eqg,n=14);   #Ƃۂ

####### \1.3 ugf[^v̐lv
hsd<-function(x){sqrt(mean((x-mean(x))^2))}#W{UɂW΍߂֐
round(apply(eqg,2,mean),1)            # 
round(apply(eqg,2,hsd),2)             # W΍
round(apply(eqg,2,quantile),1)        # ʓ_

####### }1.1 ugf[^v+ ̎Uz}
set.seed(1234);                            #̐ݒ
Reqg<-eqg+rnorm(928*2,0,0.8)      #̕t
plot(Reqg,type="p",xlim=c(155,190),ylim=c(155,190),pch=1,
   cex.axis=1.5,cex.lab=1.3)
#dev.copy2eps(file='z0101.eps',family='Japan1')

####### }1.3 Uz}ƉA (}1.1ɏdˏ)
abline(0,1,lty=2,lwd=2.0)                  #ؕ0,X1̒
abline(60.856,0.646,lty=1,lwd=2.0)         #_lɂA`
#dev.copy2eps(file='z0103.eps',family='Japan1')

###############################PAfstanR[h
reg_01<-'
//PAf
data {                                 //01
  int<lower=0>  n;                     //02f[^` p.2,l.5
  vector[n]   y;                       //03ϐ`
  vector[n]   X;                       //04\ϐ`
}
parameters {                           //05
  real        a;                       //06ؕВ`        (1.3)
  real        b;                       //07AW`    (1.3)
  real<lower=0>  sigma;                //08덷W΍`(1.5)
}
transformed parameters {               //09
  vector[n]   yhat;                    //10\l`
  for(i in 1:n)                        //11 1n܂
  yhat[i] = a + X[i]*b;                //12 \l         (1.2)
}
model {                                //13
  for(i in 1:n)                        //14 1n܂
    y[i] ~ normal(yhat[i],sigma);      //15Kz        (1.6)
}
';

par<-c("a","b","sigma")                         #ꐔ
dataSet_tankaiki01 <-list(n=nrow(eqg),y=eqg[,2], X=eqg[,1] )

###########cmdstanrɂs
modfile_tankaiki01 <- write_stan_file(reg_01)       #oꎞt@C
mod_tankaiki01 <- cmdstan_model(modfile_tankaiki01) #RpC
csrfit_tankaiki01<-mod_tankaiki01$sample(data=dataSet_tankaiki01,chains=5,
   init = function(){initi01(eqg[,2],eqg[,1])}, 
   iter_sampling=20000,iter_warmup=1000,parallel_chains=5,seed=1234)  #MCMC
fit_tankaiki01<-rstan::read_stan_csv(csrfit_tankaiki01$output_files())#stan`

###########rstanɂs
#fit_tankaiki01<-stan(model_code =reg_01,data=dataSet_tankaiki01,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fit_tankaiki01,file="./scrT/obje/stan_obje0101")
#load(file="./scrT/obje/stan_obje0101"); #\stan( )ōobject[h

ext_tankaiki01<-extract(fit_tankaiki01, par)    #o

###### \1.4 PAf̕ꐔƁCWƑ֌W̎㕪z̗viOj
gqcal(ext_tankaiki01$a)
gqcal(ext_tankaiki01$b)
gqcal(ext_tankaiki01$sigma)

hist(ext_tankaiki01$a,breaks=100)  #ؕЂ̎㕪z̃qXgO(ȏɂȂ)
hist(ext_tankaiki01$b,breaks=100)  #AW̃qXgO(ȏɂȂ)

##############֐gPA͂̎s
fit_tankaiki02<-Reg(eqg[,2],eqg[,1],cha=5, ite=21000)
#save(fit_tankaiki02,file="./scrT/obje/stan_obje0102")
#load(file="./scrT/obje/stan_obje0102"); #\stan( )ōobject[h

###### \1.4 PAf̕ꐔƁCWƑ֌W̎㕪z̗viSj
out2<-print(fit_tankaiki02)

######## 1.4.2 umvPHC
bp<-as.vector(fit_tankaiki02$b)
r2p<-as.vector(fit_tankaiki02$r2)
round(mean(bp >0.6),3); #phc(uAW0.6 傫v)  (1.21) p.9,l.10
round(mean(r2p>0.2),3); #phc(uW0.2 傫v)  (1.21) p.9,l.11

####### \1.5 AWƌWphc e[u
phc01(seq(0.54,0.60,0.01),bp,cc="gtc",byoga="no")
phc01(seq(0.14,0.20,0.01),r2p,cc="gtc",byoga="no")

####### }1.4 AWƌWphc Ȑ
par(mfrow=c(2,1));     #}1.4
phc01(seq(0.5,0.75,0.01),bp,cc="gtc",byoga="yes",xlab="AW")
phc01(seq(0.1,0.30,0.01),r2p,cc="gtc",byoga="yes",xlab="W")
par(mfrow=c(1,1))
#dev.copy2eps(file="z0104qq.eps",family="Japan1")

####### 1. 4. 4 A
####### \1.6 \l̎㕪z̗v
out3<-print(fit_tankaiki02,degits=1,Xnew=seq(155,190,2))

####### }1.5 AEmMԁE\
plot(Reqg,type="p",xlim=c(155,190),ylim=c(155,190),pch=1,
   cex.axis=1.5,cex.lab=1.3)
abline(60.856,0.646,lty=1,lwd=2.0)
lines(seq(155,190,2),out3$yhatc[,"0.025"],lty=2,lwd=2.0)
lines(seq(155,190,2),out3$yhatc[,"0.975"],lty=2,lwd=2.0)
lines(seq(155,190,2),out3$yastc[,"0.025"],lty=3,lwd=2.0)
lines(seq(155,190,2),out3$yastc[,"0.975"],lty=3,lwd=2.0)
#dev.copy2eps(file='z0104.eps',family='Japan1');            #}1.5܂

####### \1.7 ϐ̎\z̗v
Xnew=seq(155,190,5)
out4<-print(fit_tankaiki02,degits=1,Xnew=Xnew)

####### }1.6 cvbg(\ϐƎc̎Uz})
plot(eqg[,1],out2$resi,type="p",xlim=c(155,190),pch=1,
   cex.axis=1.5,cex.lab=1.3,xlab='e',ylab='c')
abline(h=0,lwd=2);                                          #}1.6܂
#dev.copy2eps(file='z0105.eps',family='Japan1')

##############h
#upX^vf[^
x1<- c(130,268,104,185,128,147,162, 68,142,175); #
x2<- c(110,232,176,207,122,202,191,124,193,250); #ڑ
x<-cbind(x1,x2)
