############8́@ɐi񂾎v
# Working directory 'toyoda' ł邱Ƃ̊mF
(n_wd<-getwd())                #working directory(wd)̊mF
(setwd('./scrT'))              #wd̈ړ
source('../myfunc/myfunc.R')   #֐̓ǂݍ
(setwd(n_wd))                  #wd߂
library(rstan)                 #pbP[WrstaňĂяo
library(cmdstanr)              #pbP[WcmdstanřĂяo
library(posterior)             #pbP[WposteriořĂяo
prob<-c(0.025, 0.05, 0.5, 0.95, 0.975) #m_̒`

###################8. 1 Ή̂1 v̐

###### 8. 1. 1 G2 _臂̊o

###### \8.1 G2 _臂̊of[^
(GQ_<-read.csv("./scrT/dat/GQ_.csv", header = TRUE))

###### }8.1 G2 _臂̑l(ʂmm)
boxplot(GQ_$~GQ_$bui,xlab="",ylab="",cex.axis=2,cex.lab=2)
#dev.copy2eps(file="z0601.eps",family='Japan1')

###### ʂƂ̐G2 _臂̑l̕ρEsd    p.111,bl.2
tapply(GQ_$,GQ_$,mean)
tapply(GQ_$,GQ_$,sd)

###### }8.2 G2 _臂̑l(팱҂mm)
boxplot(GQ_$~GQ_$팱,xlab="팱",cex.axis=1.4,cex.lab=1.5)
#dev.copy2eps(file="z0602.eps",family='Japan1')

###### 팱҂Ƃ̐G2 _臂̑l̕ρEsd  p.112,A̓IȐl͂Ȃ
tapply(GQ_$,GQ_$팱,mean)
tapply(GQ_$,GQ_$팱,sd)

#######################Ή̂1v̐stanR[h
RBlockD<-'
data { 
  int<lower=0>  n;                     //Sf[^ 
  int<lower=0>  J;                     //Q
  int<lower=0>  K;                     //ubN
  vector[n]     y;                     //ϐ   
  int<lower=0>  j[n];                  //ޕϐA 
  int<lower=0>  k[n];                  //ubNϐB 
}
parameters {
  vector[J]   mu;                      //eQ̌
  vector[K]   s;                       //ubŇ
  real<lower=0> s_e;                   //덷SD
  real<lower=0> s_s;                   //ubNSD
}
model {
    y ~ normal(mu[j]+s[k], s_e);       //(8.1),(8.2)
    s ~ normal(0, s_s);                //(8.3)
}
generated quantities{
  real tmu;                            //S
  real s_mu;                           //vSD
  tmu = mean(mu);                      //j̕
  s_mu =sqrt(variance(mu)*(J-1)/J);    //ĵ
}
';
par<-c("mu","s_e","s_s","tmu","s_mu","s");                      #ꐔ
dataSetran <-list(n=length(GQ_$),J=max(GQ_$), #
  K=max(GQ_$팱),y=GQ_$,j=GQ_$,k=GQ_$팱)

###########cmdstanrɂs
modfileran <- write_stan_file(RBlockD)             #oꎞt@C
modran <- cmdstan_model(modfileran)                   #RpC
csrfitran <- modran$sample(data = dataSetran,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitran <- rstan::read_stan_csv(csrfitran$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitran<-stan(model_code =RBlockD,data=dataSetran,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitran,  file="./scrT/obje/stan_obje0801")
#load(file="./scrT/obje/stan_obje0801"); #\stan( )ōobject[h

extran<-extract(fitran, par)

###### \8.2 v̕ꐔ̎㕪z
eta2 = (extran$s_mu^2)/((extran$s_mu^2)+(extran$s_e^2));#(8.5)
gqcal(extran$mu[,1])
gqcal(extran$mu[,2])
gqcal(extran$mu[,3])
print('------------------------------------------')
gqcal(extran$s_e   )
gqcal(extran$s_s   )
print('------------------------------------------')
gqcal(extran$tmu   )
gqcal(extran$s_mu  )
print('------------------------------------------')
gqcal(extran$s[,4] )
print('------------------------------------------')
gqcal(eta2)

###### QԂɍmiӖ邽߂̕Kv̊mFjp.114,bl.2
mean(extran$mu[,1]>extran$mu[,2])
mean(extran$mu[,2]>extran$mu[,3])
mean(extran$mu[,1]>extran$mu[,3])

###### }8.3 ϒl̍Ɋւphc Ȑ
par(mfrow=c(2,1));                                    #}8.3
phc01(seq01=seq(0,1.2,0.05),a=extran$mu[,1],b=extran$mu[,2],
  xlab="c<1-2")
phc01(seq01=seq(0,1.2,0.05),a=extran$mu[,2],b=extran$mu[,3],
  xlab="c<2-3")
par(mfrow=c(1,1))
#dev.copy2eps(file="z0603.eps",family='Japan1')

###### IɍƖłm p115,l.3
phc01(0.7,a=extran$mu[,1],b=extran$mu[,2],byoga="no")
phc01(0.5,a=extran$mu[,2],b=extran$mu[,3],byoga="no")


#############8. 2 lXg1 v̐
####### 8. 2. 1 HۑɂlY~̐݊wK

####### \8.3 HۑɂlY~̐݊wK̃f[^
(݊wK<-read.csv("./scrT/dat/݊wK.csv", header = TRUE))

###### }8.4 HۑɂlY~̐݊wK()
boxplot(݊wK$time~݊wK$jyok,xlab="",cex.lab=1.2,cex.axis=1.8)
#dev.copy2eps(file="z0604.eps",family='Japan1')

###### }8.5 HۑɂlY~̐݊wK(lY~)
boxplot(݊wK$time~݊wK$lY~, xlab="lY~", ylab="")
#dev.copy2eps(file="z0605.eps",family='Japan1')

###### Ƃ̕ϒlsd iȏɂ͋̓IlȂj
tapply(݊wK$time,݊wK$,mean)
tapply(݊wK$time,݊wK$,sd)

############################lXg1v̐stanR[h
nestedD<-'
data { 
  int<lower=0>  n;                     //Sf[^ 
  int<lower=0>  J;                     //Q
  int<lower=0>  K;                     //ubN
  vector[n]     y;                     //ϐ   
  int<lower=0>  j[n];                  //ޕϐA 
  int<lower=0>  k[n];                  //ubNϐB 
}
parameters {
  vector[J]     mu;                    //eQ̌
  vector[J*K]   s;                     //ubŇ
  real<lower=0> s_e;                   //덷SD
  real<lower=0> s_s;                   //ubNSD
}
model {
    y ~ normal(mu[j]+s[k], s_e);       //(8.6),(8.7)
    s ~ normal(0, s_s);                //(8.8)
}
';

par<-c("mu","s_e","s_s")                                          #ꐔ
dataSetnest <-list(n=length(݊wK$time), J=max(݊wK$), #
 K=max(݊wK$lY~),y=݊wK$time,j=݊wK$,k=݊wK$lY~)

###########cmdstanrɂs
modfilenest <- write_stan_file(nestedD)             #oꎞt@C
modnest <- cmdstan_model(modfilenest)               #RpC
csrfitnest <- modnest$sample(data=dataSetnest,chains=5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitnest <- rstan::read_stan_csv(csrfitnest$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitnest<-stan(model_code =nestedD,data=dataSetnest,   
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitnest,  file="./scrT/obje/stan_obje0802")
#load(file="./scrT/obje/stan_obje0802"); #\stan( )ōobject[h

extnest<-extract(fitnest, par);               #̎o

###### \8.4 }v̕ꐔƐʂ̎㕪z̗v(O)
gqcal(extnest$mu[,1])
gqcal(extnest$mu[,2])
gqcal(extnest$mu[,3])
gqcal(extnest$s_e   )
gqcal(extnest$s_s   )

###### \8.4i㔼jϒl̍̎㕪z
def32 = extnest$mu[,3]-extnest$mu[,2];    #(8.10)
def13 = extnest$mu[,1]-extnest$mu[,3];    #(8.11)
gqcal(def32);
gqcal(def13);                                         #\8.4܂



#####################8. 3 Ή2 v̐
###### 8. 3. 1 IbZ[W̔r

###### \8.5 IbZ[W̔rf[^
(֏W<-read.csv("./scrT/dat/֏W.csv", header = TRUE))

###### }8.6 ZƂ̔Ђ}
boxplot(֏W$]~֏W$W+֏W$katu,xlab="W/",ylab="]")
#dev.copy2eps(file="z0606.eps",family='Japan1')

###### }8.7 팱҂Ƃ̔Ђ}
boxplot(֏W$]~֏W$팱,xlab="팱", ylab="]")
#dev.copy2eps(file="z0607.eps",family='Japan1')

#######################################Ή2v̐stanR[h
RBFD<-'
//vvE팱ғ2v KP@Q
functions{
  vector zero_sum_vector(int a, vector m1A){//ʃ[a
    vector[a] muA;            
    for(i in 1:(a-1)){ muA[i]  = m1A[i];}   //a-1܂ł̓\bN
    muA[a]  = -sum(m1A);                    //aԖڂɁAa-1{
    return(muA);
  }
  matrix zero_sum_matrix(int a, int b, matrix m1AB){//ݍp[a
    vector [a-1] m1a;                       //saxNg
    vector [b-1] m1b;                       //axNg
    matrix [a,b] muAB;                      //^[s
    for(i in 1:(a-1)){ m1a[i]  = 0.0;}      //[NA
    for(j in 1:(b-1)){ m1b[j]  = 0.0;}      //[NA
    for(i in 1:(a-1)){ for(j in 1:(b-1)){muAB[i,j] =m1AB[i,j];}}//\bN
    for(i in 1:(a-1)){ for(j in 1:(b-1)){m1a[i] =m1a[i]+m1AB[i,j];}}//sa
    for(j in 1:(b-1)){ for(i in 1:(a-1)){m1b[j] =m1b[j]+m1AB[i,j];}}//a
    for(i in 1:(a-1)){muAB[i,b] = (-1)*m1a[i]; }    //bɍsa-1{
    for(j in 1:(b-1)){muAB[a,j] = (-1)*m1b[j]; }    //asɗa-1{
    muAB[a,b] = sum(m1a);  //asbvfɍvAӁF}CiXł͂Ȃ
    return(muAB);
  }
}
data { 
  int<lower=0>  n;                             //Sf[^ 
  int<lower=0>  a;                             //A
  int<lower=0>  b;                             //B
  int<lower=0>  s;                             //ubN
  vector[n]     y;                             //ϐ   
  int<lower=0>  A[n];                          //ޕϐA 
  int<lower=0>  B[n];                          //ޕϐB 
  int<lower=0>  S[n];                          //ubNϐs 
}
parameters {
  real                           mu;           //S
  vector                   [a-1] m1A;          //A1Ȃ
  vector                   [b-1] m1B;          //B1Ȃ
  vector                   [s-1] m1S;          //S1Ȃ
  matrix               [a-1,b-1] m1AB;         //ݍp1Ȃ
  matrix               [a-1,s-1] m1AS;         //ݍpAS1Ȃ
  matrix               [b-1,s-1] m1BS;         //ݍpBS1Ȃ
  real<lower=0>             s_E;               //EW΍
  real<lower=0>             s_S;               //SW΍
  real<lower=0>             s_AS;              //ASW΍
  real<lower=0>             s_BS;              //BSW΍
}
transformed parameters {
  vector                   [a] muA;            //A
  vector                   [b] muB;            //B
  matrix                 [a,b] muAB;           //ݍp
  muA =zero_sum_vector(a, m1A);                //p.121(8.12)2sA1
  muB =zero_sum_vector(b, m1B);                //2
  muAB=zero_sum_matrix(a, b, m1AB);            //3C4
}
model {
  vector                   [s] muS;            //S
  matrix                 [a,s] muAS;           //ݍpAS
  matrix                 [b,s] muBS;           //ݍpBS
  m1S ~ normal(0,s_S);                         //p.121(8.12)1sA2
  muS =zero_sum_vector(s, m1S);                //p.125(8.13)2sA1
  for(j in 1:a-1){  for(l in 1:s-1){m1AS[j,l] ~ normal(0,s_AS);}}//  3
  for(k in 1:b-1){  for(l in 1:s-1){m1BS[k,l] ~ normal(0,s_BS);}}//  4
  muAS=zero_sum_matrix(a, s, m1AS);            //as̘a0ɂ
  muBS=zero_sum_matrix(b, s, m1BS);            //bs̘a0ɂ
  for(i in 1:n){
     y[i] ~ normal(mu+muA[A[i]]+muB[B[i]]+muS[S[i]]+
            muAB[A[i],B[i]]+muAS[A[i],S[i]]+muBS[B[i],S[i]],s_E);}//(8.12)
}
generated quantities{
  real s_a;                                    //vASD
  real s_b;                                    //vBSD
  real s_ab;                                   //ݍpABSD
  s_a =sqrt(variance(muA)*(a-1)/a);            //vAsd
  s_b =sqrt(variance(muB)*(b-1)/b);            //vBsd
  s_ab =sqrt(variance(muAB)*((a*b)-1)/(a*b));  //ݍpABsd
}
';

par<-c("mu","muA","muB","muAB","s_S","s_AS",
       "s_BS","s_E","s_a","s_b","s_ab")                           #ꐔ
dataSetRBFD <-list(n=length(֏W$]), a=max(֏W$W),
   b=max(֏W$), s=max(֏W$팱), y=֏W$],
   A=֏W$W, B=֏W$, S=֏W$팱)           #

###########cmdstanrɂs
modfileRBFD <- write_stan_file(RBFD)             #oꎞt@C
modRBFD <- cmdstan_model(modfileRBFD)            #RpC
csrfitRBFD <- modRBFD$sample(data=dataSetRBFD,chains=5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitRBFD <- rstan::read_stan_csv(csrfitRBFD$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitRBFD<-stan(model_code =RBFD,data=dataSetRBFD,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitRBFD,  file="./scrT/obje/stan_obje0803")
#load(file="./scrT/obje/stan_obje0803"); #\stan( )ōobject[h

extRBFD<-extract(fitRBFD, par);               #̎o

###### \8.6 vv̕ꐔ̎㕪z
gqcal(extRBFD$mu       )
gqcal(extRBFD$muA[,1]   )
gqcal(extRBFD$muA[,2]   )
gqcal(extRBFD$muA[,3]   )
gqcal(extRBFD$muB[,1]   )
gqcal(extRBFD$muAB[,1,1])
gqcal(extRBFD$muAB[,2,1])
gqcal(extRBFD$muAB[,3,1])
gqcal(extRBFD$s_S      )
gqcal(extRBFD$s_AS     )
gqcal(extRBFD$s_BS     )
gqcal(extRBFD$s_E      )
print('------------------------------------------')
gqcal(extRBFD$s_a      )
gqcal(extRBFD$s_b      )
gqcal(extRBFD$s_ab     )


###### 8. 3. 4 PHC  uށv̐Ԃɍm
phc02(0,extRBFD$muA)

#utHgv̐Ԃɍm
mean(extRBFD$muB[,2]-extRBFD$muB[,1]>0)

#A肪m uvuBv@@uBvuSv
round(mean((extRBFD$muA[,1]<extRBFD$muA[,2])&(extRBFD$muA[,2]<extRBFD$muA[,3])),3)

###### }8.8 ̌ʂc ȏ̍̂m̋Ȑ
par(mfrow=c(3,1))
phc01(seq01=seq(0.5,1.4,0.05),a=extRBFD$muA[,2],b=extRBFD$muA[,1],
        xlab="c<a2-a1",cex.lab=2.5)
phc01(seq01=seq(1,2,0.05),a=extRBFD$muA[,3],b=extRBFD$muA[,2],
        xlab="c<a3-a2",cex.lab=2.5)
phc01(seq01=seq(1,2,0.05),a=extRBFD$muB[,2],b=extRBFD$muB[,1],
        xlab="c<b2-b1",cex.lab=2.5)
par(mfrow=c(1,1))
#dev.copy2eps(file="z0608.eps",family='Japan1')

###### IɍƖłm p.123,l.3@ȍ~̃y[W̍Ō܂
phc01(seq01=0.8,a=extRBFD$muA[,2],b=extRBFD$muA[,1],byoga="no")
phc01(seq01=1.3,a=extRBFD$muA[,3],b=extRBFD$muA[,2],byoga="no")
phc01(seq01=1.5,a=extRBFD$muB[,2],b=extRBFD$muB[,1],byoga="no")


##################8. 4 2 v̐
###### 8. 4. 1 Nff̒ǐՒ

###### \8.7 Nff̒ǐՒ
(ǐ<-read.csv("./scrT/dat/ǐ.csv", header = TRUE))

###### }8.9 a̒ǐՒ Uz}₷Ă
ma<-57;mi<-48
a1<-ǐ[  1: 50,1]+runif(50)
a2<-ǐ[ 51:100,1]+runif(50)
b1<-ǐ[101:150,1]+runif(50)
b2<-ǐ[151:200,1]+runif(50)
plot(a1,a2,pch=21,xlim=c(mi,ma),ylim=c(mi,ma),xlab="pre.test",ylab="post.test")
abline(0,1)
par(new=T)
plot(b1,b2,pch=19,xlim=c(mi,ma),ylim=c(mi,ma),xlab="",ylab="")
legend(49,56,c("ΏƌQ","Q"),pch=c(21,19));               #}8.9܂


#####################2v̐stanR[h
SPD<-'
functions{
  vector zero_sum_vector(int a, vector m1A){//ʃ[a
    vector[a] muA;            
    for(i in 1:(a-1)){ muA[i]  = m1A[i];}   //a-1܂ł̓\bN
    muA[a]  = -sum(m1A);                    //aԖڂɁAa-1{
    return(muA);
  }
  matrix zero_sum_matrix(int a, int b, matrix m1AB){//ݍp[a
    vector [a-1] m1a;                       //saxNg
    vector [b-1] m1b;                       //axNg
    matrix [a,b] muAB;                      //^[s
    for(i in 1:(a-1)){ m1a[i]  = 0.0;}      //[NA
    for(j in 1:(b-1)){ m1b[j]  = 0.0;}      //[NA
    for(i in 1:(a-1)){ for(j in 1:(b-1)){muAB[i,j] =m1AB[i,j];}}//\bN
    for(i in 1:(a-1)){ for(j in 1:(b-1)){m1a[i] =m1a[i]+m1AB[i,j];}}//sa
    for(j in 1:(b-1)){ for(i in 1:(a-1)){m1b[j] =m1b[j]+m1AB[i,j];}}//a
    for(i in 1:(a-1)){muAB[i,b] = (-1)*m1a[i]; }    //bɍsa-1{
    for(j in 1:(b-1)){muAB[a,j] = (-1)*m1b[j]; }    //asɗa-1{
    muAB[a,b] = sum(m1a);  //asbvfɍvAӁF}CiXł͂Ȃ
    return(muAB);
  }
}
data { 
  int<lower=0>  n;                             //Sf[^ 
  int<lower=0>  a;                             //AiW{ԗvj
  int<lower=0>  b;                             //BiW{vj
  int<lower=0>  s;                             //ubN
  vector[n]     y;                             //ϐ   
  int<lower=0>  A[n];                          //ޕϐAiW{ԗvj
  int<lower=0>  B[n];                          //ޕϐBiW{vj
  int<lower=0>  S[n];                          //ubNϐs 
}
parameters {
  real                           mu;           //S
  vector                   [a-1] m1A;          //A1Ȃ
  vector                   [b-1] m1B;          //B1Ȃ
  vector                 [s*a-1] m1S;          //S1Ȃ
  matrix               [a-1,b-1] m1AB;         //ݍp1Ȃ
  real<lower=0>             s_E;               //EW΍
  real<lower=0>             s_S;               //SW΍
}
transformed parameters {
  vector                   [a] muA;            //A
  vector                   [b] muB;            //B
  matrix                 [a,b] muAB;           //ݍp
  muA =zero_sum_vector(a, m1A);                //p.125(8.13)2sA1
  muB =zero_sum_vector(b, m1B);                //2
  muAB=zero_sum_matrix(a, b, m1AB);            //3C4
}
model {
  vector                 [s*a] muS;            //S
  m1S ~ normal(0,s_S);                         //p.125(8.13)1sA2
  muS =zero_sum_vector(s*a, m1S);              //p.125(8.13)2sA1
  for(i in 1:n){
     y[i] ~ normal(mu+muA[A[i]]+muB[B[i]]+muS[S[i]]+
        muAB[A[i],B[i]],s_E);}                 //(8.13)
}
generated quantities{
  real s_a;                                    //vASD
  real s_b;                                    //vBSD
  real s_ab;                                   //ݍpABSD
  s_a =sqrt(variance(muA)*(a-1)/a);            //vAsd
  s_b =sqrt(variance(muB)*(b-1)/b);            //vBsd
  s_ab =sqrt(variance(muAB)*((a*b)-1)/(a*b));  //ݍpABsd
}
';
par<-c("mu","muA","muB","muAB","s_S","s_E","s_a","s_b","s_ab")    #ꐔ
dataSetSPD <-list(n=length(ǐ$score),a=max(ǐ$Q),
    b=max(ǐ$),s=max(ǐ$w),y=ǐ$score,
    A=ǐ$Q, B=ǐ$, S=ǐ$w)              #

###########cmdstanrɂs
modfileSPD <- write_stan_file(SPD)             #oꎞt@C
modSPD <- cmdstan_model(modfileSPD)                   #RpC
csrfitSPD <- modSPD$sample(data = dataSetSPD,chains = 5,iter_sampling = 20000,
    iter_warmup = 1000,parallel_chains = 5,seed=1234)  #MCMC
fitSPD <- rstan::read_stan_csv(csrfitSPD$output_files()) #stan`ւ̕ϊ

###########rstanɂs
#fitSPD<-stan(model_code =SPD,data=dataSetSPD,
#  pars=par, seed=1234, chains=5, warmup=1000,  iter=21000)
#save(fitSPD,  file="./scrT/obje/stan_obje0804")
#load(file="./scrT/obje/stan_obje0804"); #\stan( )ōobject[h

extSPD<-extract(fitSPD, par);               #̎o

######\8.8 v̕ꐔ̎㕪z̗v
gqcal(extSPD$mu        )
gqcal(extSPD$muA[,1]   )
gqcal(extSPD$muB[,1]   )
gqcal(extSPD$muAB[,1,1])
gqcal(extSPD$muAB[,1,2])
gqcal(extSPD$muAB[,2,1])
gqcal(extSPD$muAB[,2,2])
gqcal(extSPD$s_S       )
gqcal(extSPD$s_E       )
print('------------------------------------------')
gqcal(extSPD$s_a       )
gqcal(extSPD$s_b       )
gqcal(extSPD$s_ab      )


####(j Ԗڂ̌Qk Ԗڂ̎̃Zjk ̌)̎㕪z  (8.15)
ce11<-extSPD$muA[,1]+extSPD$muB[,1]+extSPD$muAB[,1,1]
ce12<-extSPD$muA[,1]+extSPD$muB[,2]+extSPD$muAB[,1,2]
ce21<-extSPD$muA[,2]+extSPD$muB[,1]+extSPD$muAB[,2,1]
ce22<-extSPD$muA[,2]+extSPD$muB[,2]+extSPD$muAB[,2,2]

###### \8.9 Q̎̎㕪z
gqcal(ce11-ce12);             #(8.16)
gqcal(ce21-ce22);

###### Q̎̎㕪z̃qXgOiȏɂ͂Ȃj
hist(ce11-ce12,main="",ylab="")
hist(ce21-ce22,main="",ylab="")

################################# Kۑ
#1
#def32
phc01(seq01=seq(-3,6,0.05),a=def32,cc="gtc",byoga="yes",xlab="d32",cex.lab=2.5)
phc01(seq01=seq(-3,6,0.5 ),a=def32,cc="gtc",byoga="no")

#def32,ROPE
phc01(seq01=seq(0,6,0.05),a=def32,cc="rope",byoga="yes",xlab="|d32|<c",
      cex.lab=2.5)
phc01(seq01=seq(0,6,0.5 ),a=def32,cc="rope",byoga="no")

#def13
phc01(seq01=seq(17,25,0.05),a=def13,cc="gtc",byoga="yes",xlab="d32",
      cex.lab=2.5)
phc01(seq01=seq(17,25,0.5),a=def13,cc="gtc",byoga="no")

#2

#
#     ͊
#
